-- Title: ClassExchangeHelper
-- Version: 1.31
-- Author: Pyrrhus
CEH = {}

CEH.func = {}

CEH.Data= {
	loaded=false,
	ver="1.31",
	Hook,
	class1={name,ID,lvl,tag="space"},
	class2={name,ID,lvl,tag="space"},
	class3={name,ID,lvl,tag="space"},
	name="ClassExchangeHelper",
	}
			
function CEH.func.OnLoad()
	DEFAULT_CHAT_FRAME:AddMessage("|H|h|cffbbbbFF|hCEH v"..CEH.Data.ver.. " loaded");
end

		
local language = string.sub(GetLanguage(), 1, 2)
local func, error = loadfile("Interface/AddOns/ClassExchangeHelper/loka/lang_"..language..".lua")
if error then
	dofile("Interface/AddOns/ClassExchangeHelper/loka/lang_EN.lua")
else
	func()
end
	

	
function CEH.func.SetAddonManager()
	if AddonManager then
		local addon = {
			name = "ClassExchangeHelper",
			version = CEH.Data.ver,
			author = "Pyrrhus",
			description = CEH.locale.description,
			icon = nil,
			category = "Interface",
			configFrame = nil,
			slashCommand = nil,
			miniButton = nil,
			disableScript = CEH.func.SetHook,
			enableScript = CEH.func.SetHook,
		};

		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author);
		end;
	end
end

function CEH.func.RegisterEvent(this)
	this:RegisterEvent("LOADING_END")
end

function CEH.func.OnEvent(event)
	if event == "EXCHANGECLASS_SHOW" then
		CEH.func.AltKey()
	elseif ( event == "EXCHANGECLASS_CLOSED" ) then
		HideUIPanel(CEHFrame);
	elseif ( event == "EXCHANGECLASS_SUCCESS" ) then
		HideUIPanel(CEHFrame);
	elseif ( event == "EXCHANGECLASS_FAILED" ) then
		--ExchangeClassOkayButton:Enable();
	elseif(event == "LOADING_END") then
		if not CEH.Data.loaded then
			CEH.func.SetAddonManager()
			CEH.func.Changename()
			CEH.func.Hook()
			CEH.func.SetText()
			CEH.Data.loaded = true
		end
	end
end

function CEH.func.AltKey()
local EXCHANGECLASS_MAINCLASS = nil;
local EXCHANGECLASS_SUBCLASS = nil;
	if IsAltKeyDown() then	
		local mainClass, subClass = UnitClass("player");
		for index = 1, GetNumClasses() do
			class= GetPlayerClassInfo(index);
			if ( class ) then		
				if ( class == mainClass ) then
					EXCHANGECLASS_MAINCLASS = index;
				elseif ( class == subClass ) then
					EXCHANGECLASS_SUBCLASS = index;
				end
			end
		end	
		if ( subClass == "" ) then
			EXCHANGECLASS_SUBCLASS = 0;
		end
	else
		CEH.func.Changename()
		CEHFrame:Show()
		CEH.func.ChangeFrameShow()			
	end
	if IsAltKeyDown() and EXCHANGECLASS_SUBCLASS ~= 0 then
		ExchangeClass(EXCHANGECLASS_SUBCLASS, EXCHANGECLASS_MAINCLASS);
		CloseExchangeClass();
	else
		CEH.func.Changename()
		CEHFrame:Show()
		CEH.func.ChangeFrameShow()	
	end	
		
end

function CEH.func.SetText()
CEHFrame_name:SetText(TEXT("HOUSE_MAID_HOUSE_CHANGEJOB") )
CEHFrame_ver:SetText("|H|h|cffbbbbFF|hCEH |H|h|cffbbFFbb|hv"..CEH.Data.ver)
end

local classtable = {
	[1] = {A1 = "GM" , 		A2 = 1 , A3 = "gm"},
	[2] = {A1 = "WARRIOR" , A2 = 2 , A3 = "warrior"},
	[3] = {A1 = "RANGER" , 	A2 = 3 , A3 = "ranger"},
	[4] = {A1 = "THIEF" , 	A2 = 4 , A3 = "thief"},
	[5] = {A1 = "MAGE" , 	A2 = 5 , A3 = "mage"},
	[6] = {A1 = "AUGUR" , 	A2 = 6 , A3 = "augur"},
	[7] = {A1 = "KNIGHT" , 	A2 = 7 , A3 = "knight"},
	[8] = {A1 = "WARDEN" , 	A2 = 8 , A3 = "warden"},
	[9] = {A1 = "DRUID" , 	A2 = 9 , A3 = "druid"},
	}
	

function CEH.func.Changename()
CEH.Data.class1.name, _, CEH.Data.class1.lvl, _, _ = GetPlayerClassInfo(1, true);
CEH.Data.class2.name, _, CEH.Data.class2.lvl, _, _ = GetPlayerClassInfo(2, true);
CEH.Data.class3.name, _, CEH.Data.class3.lvl, _, _ = GetPlayerClassInfo(3, true);

--class, token, level, currExp, maxExp = GetPlayerClassInfo(1);
	for i, v in ipairs(classtable) do
		if CEH.Data.class1.name == GetSystemString("SC_VOC_"..v.A1) then
			CEH.Data.class1.ID = v.A2
			CEH.Data.class1.tag = v.A3
		end
	end

	for i, v in ipairs(classtable) do
		if CEH.Data.class2.name == GetSystemString("SC_VOC_"..v.A1) then
			CEH.Data.class2.ID = v.A2
			CEH.Data.class2.tag = v.A3
		end
	end

	for i, v in ipairs(classtable) do
		if CEH.Data.class3.name == GetSystemString("SC_VOC_"..v.A1) then
			CEH.Data.class3.ID = v.A2
			CEH.Data.class3.tag = v.A3
		end
	end
end

function CEH.func.SetHook()
	if not CEH.Data.Hook then 
		CEH.func.Hook()
		DEFAULT_CHAT_FRAME:AddMessage("|H|h|cff00ff00|hCEH "..CEH.locale.active);
	else
		CEH.func.UnHook()
		DEFAULT_CHAT_FRAME:AddMessage("|H|h|cffff0000|hCEH "..CEH.locale.inactive);
	end

end

-- create hooks
function CEH.func.Hook()

    CEH.ToggleUIFrame = ToggleUIFrame;
	
    function ToggleUIFrame(frame)
        if(frame == ExchangeClassFrame) then frame = CEHFrame; end;
        CEH.ToggleUIFrame(frame);
    end;   

    local success,errmsg = pcall(CEH.func.InitGameFrames);
    if not success then 
		SendWarningMsg("|cffbbbbbbCEH- FrameInit: "..errmsg);
    end;    
	CEH.Data.Hook=true;
end;

function CEH.func.InitGameFrames()
	CEHFunc:RegisterEvent("EXCHANGECLASS_SHOW")
	CEHFunc:RegisterEvent("EXCHANGECLASS_CLOSED");
	CEHFunc:RegisterEvent("EXCHANGECLASS_SUCCESS");
	CEHFunc:RegisterEvent("EXCHANGECLASS_FAILED");	

    ExchangeClassFrame:UnregisterEvent("EXCHANGECLASS_SHOW")
	ExchangeClassFrame:UnregisterEvent("EXCHANGECLASS_CLOSED");
	ExchangeClassFrame:UnregisterEvent("EXCHANGECLASS_SUCCESS");
	ExchangeClassFrame:UnregisterEvent("EXCHANGECLASS_FAILED");
    
end;

function CEH.func.UnHook()
    ToggleUIFrame= CEH.ToggleUIFrame;
	
	CEHFunc:UnregisterEvent("EXCHANGECLASS_SHOW")
	CEHFunc:UnregisterEvent("EXCHANGECLASS_CLOSED");
	CEHFunc:UnregisterEvent("EXCHANGECLASS_SUCCESS");
	CEHFunc:UnregisterEvent("EXCHANGECLASS_FAILED");	
	
    ExchangeClassFrame:RegisterEvent("EXCHANGECLASS_SHOW")
	ExchangeClassFrame:RegisterEvent("EXCHANGECLASS_CLOSED");
	ExchangeClassFrame:RegisterEvent("EXCHANGECLASS_SUCCESS");
	ExchangeClassFrame:RegisterEvent("EXCHANGECLASS_FAILED");	
	CEH.Data.Hook=false;
end;

function CEH.func.ChangeFrameShow()	
	CEH_Class1:SetMouseEnable(true);
	CEH_Class2:SetMouseEnable(true);
	CEH_Class3:SetMouseEnable(true);
	CEH_Change_Button1_Left:SetMouseEnable(true);
	CEH_Change_Button1_Right:SetMouseEnable(true);
	CEH_Change_Button2_Left:SetMouseEnable(true);
	CEH_Change_Button2_Right:SetMouseEnable(true);
	CEH_Change_Button3_Left:SetMouseEnable(true);
	CEH_Change_Button3_Right:SetMouseEnable(true);
	CEH_Change_Button4_Left:SetMouseEnable(true);
	CEH_Change_Button4_Right:SetMouseEnable(true);
	CEH_Change_Button5_Left:SetMouseEnable(true);
	CEH_Change_Button5_Right:SetMouseEnable(true);
	CEH_Change_Button6_Left:SetMouseEnable(true);
	CEH_Change_Button6_Right:SetMouseEnable(true);
	CEH_Change_Button7_Left:SetMouseEnable(true);
	CEH_Change_Button7_Right:SetMouseEnable(true);
	CEH_Change_Button8_Left:SetMouseEnable(true);
	CEH_Change_Button8_Right:SetMouseEnable(true);
		
	if CEH.Data.class3.name == nil then
	--changing all settings into 2 button frame
		CEH_Change_Button1:Disable()
		CEH_Change_Button2:Disable()
		CEH_Change_Button3:Disable()
		CEH_Change_Button4:Disable()
		CEH_Change_Button5:Disable()
		CEH_Change_Button6:Disable()
		CEH_Change_Button1:Hide()
		CEH_Change_Button2:Hide()
		CEH_Change_Button3:Hide()
		CEH_Change_Button4:Hide()
		CEH_Change_Button5:Hide()
		CEH_Change_Button6:Hide()
		CEHFrame:SetSize(360,200);
		CEH_Change_Button7:Enable()
		CEH_Change_Button8:Enable()
		CEH_Change_Button7:Show()
		CEH_Change_Button8:Show()
		CEH_Class3:Hide()
		CEH_Change_Button7:SetText(CEH.Data.class1.lvl .." " .. CEH.Data.class1.name .. " / " .. CEH.Data.class2.name .." " ..CEH.Data.class2.lvl)	
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button7_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button7_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		CEH_Change_Button8:SetText(CEH.Data.class2.lvl .." " .. CEH.Data.class2.name .. " / " .. CEH.Data.class1.name .." " ..CEH.Data.class1.lvl)
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button8_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button8_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Class1, "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag ..".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Class2, "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag ..".tga", 40 , 40 );
		CEH_Class1:SetSize(40,40)
		CEH_Class2:SetSize(40,40)
		CEH_Change_Button7_Left:SetSize(40,40)
		CEH_Change_Button7_Right:SetSize(40,40)	
		CEH_Change_Button8_Left:SetSize(40,40)
		CEH_Change_Button8_Right:SetSize(40,40)	
		CEH_Class1:ClearAllAnchors()
		CEH_Class1:SetAnchor("RIGHT", "LEFT", "CEH_Class3", -5, 0)
		CEH_Class2:ClearAllAnchors()
		CEH_Class2:SetAnchor("LEFT", "RIGHT", "CEH_Class3", 5, 0)
	elseif CEH.Data.class3.name ~= nil then
	--changing all settings into 3 button frame
		CEH_Change_Button1:Enable()
		CEH_Change_Button2:Enable()
		CEH_Change_Button3:Enable()
		CEH_Change_Button4:Enable()
		CEH_Change_Button5:Enable()
		CEH_Change_Button6:Enable()
		CEH_Change_Button1:Show()
		CEH_Change_Button2:Show()
		CEH_Change_Button3:Show()
		CEH_Change_Button4:Show()
		CEH_Change_Button5:Show()
		CEH_Change_Button6:Show()
		CEHFrame:SetSize(360,350);
		CEH_Change_Button7:Disable()
		CEH_Change_Button8:Disable()
		CEH_Change_Button7:Hide()
		CEH_Change_Button8:Hide()
		CEH_Class3:Show()
		CEH_Change_Button1:SetText(CEH.Data.class1.lvl .." " .. CEH.Data.class1.name .. " / " .. CEH.Data.class2.name .." " ..CEH.Data.class2.lvl)	
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button1_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button1_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		CEH_Change_Button2:SetText(CEH.Data.class1.lvl .." " .. CEH.Data.class1.name .. " / " .. CEH.Data.class3.name .." " ..CEH.Data.class3.lvl)
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button2_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class3.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button2_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag .."_".. CEH.Data.class3.tag .. ".tga", 40 , 40 );
		CEH_Change_Button3:SetText(CEH.Data.class2.lvl .." " .. CEH.Data.class2.name .. " / " .. CEH.Data.class1.name .." " ..CEH.Data.class1.lvl)
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button3_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button3_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		CEH_Change_Button4:SetText(CEH.Data.class2.lvl .." " .. CEH.Data.class2.name .. " / " .. CEH.Data.class3.name .." " ..CEH.Data.class3.lvl)
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button4_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class3.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button4_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag .."_".. CEH.Data.class3.tag .. ".tga", 40 , 40 );
		CEH_Change_Button5:SetText(CEH.Data.class3.lvl .." " .. CEH.Data.class3.name .. " / " .. CEH.Data.class1.name .." " ..CEH.Data.class1.lvl)
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button5_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class3.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button5_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class3.tag .."_".. CEH.Data.class1.tag .. ".tga", 40 , 40 );
		CEH_Change_Button6:SetText(CEH.Data.class3.lvl .." " .. CEH.Data.class3.name .. " / " .. CEH.Data.class2.name .." " ..CEH.Data.class2.lvl)	
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button6_Left , "/interface/widgeticons/classicon_" .. CEH.Data.class3.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Change_Button6_Right, "/interface/widgeticons/classicon_" .. CEH.Data.class3.tag .."_".. CEH.Data.class2.tag .. ".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Class1, "/interface/widgeticons/classicon_" .. CEH.Data.class1.tag ..".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Class2, "/interface/widgeticons/classicon_" .. CEH.Data.class2.tag ..".tga", 40 , 40 );
		UIPanelBackdropFrame_SetTexture(CEH_Class3, "/interface/widgeticons/classicon_" .. CEH.Data.class3.tag ..".tga", 40 , 40 );
		CEH_Class1:SetSize(40,40)
		CEH_Class2:SetSize(40,40)
		CEH_Class3:SetSize(40,40)
		CEH_Change_Button1_Left:SetSize(40,40)
		CEH_Change_Button1_Right:SetSize(40,40)	
		CEH_Change_Button2_Left:SetSize(40,40)
		CEH_Change_Button2_Right:SetSize(40,40)	
		CEH_Change_Button3_Left:SetSize(40,40)
		CEH_Change_Button3_Right:SetSize(40,40)	
		CEH_Change_Button4_Left:SetSize(40,40)
		CEH_Change_Button4_Right:SetSize(40,40)	
		CEH_Change_Button5_Left:SetSize(40,40)
		CEH_Change_Button5_Right:SetSize(40,40)	
		CEH_Change_Button6_Left:SetSize(40,40)
		CEH_Change_Button6_Right:SetSize(40,40)	
		CEH_Class1:ClearAllAnchors()
		CEH_Class1:SetAnchor("RIGHT", "LEFT", "CEH_Class3", -20, 0)
		CEH_Class2:ClearAllAnchors()
		CEH_Class2:SetAnchor("LEFT", "RIGHT", "CEH_Class3", 20, 0)
	end
	
	local class1,class2 = UnitClass("player");	
	if CEH.Data.class3.name == nil then	
		if CEH.Data.class1.name == class1 and "" == class2 then
			CEH_Class1:SetMouseEnable(false);
		elseif CEH.Data.class2.name == class1 and "" == class2 then
			CEH_Class2:SetMouseEnable(false);
		elseif CEH.Data.class1.name == class1 and CEH.Data.class2.name == class2 then
			CEH_Change_Button7:Disable()
			CEH_Change_Button7_Left:SetMouseEnable(false);
			CEH_Change_Button7_Right:SetMouseEnable(false);
		elseif CEH.Data.class2.name == class1 and CEH.Data.class1.name == class2 then
			CEH_Change_Button8:Disable()	
			CEH_Change_Button8_Left:SetMouseEnable(false);
			CEH_Change_Button8_Right:SetMouseEnable(false);
		end
	end
		
	if CEH.Data.class3.name ~= nil then
		if CEH.Data.class1.name == class1 and "" == class2 then
			CEH_Class1:SetMouseEnable(false);
		elseif CEH.Data.class2.name == class1 and "" == class2 then
			CEH_Class2:SetMouseEnable(false);
		elseif CEH.Data.class3.name == class1 and "" == class2 then
			CEH_Class3:SetMouseEnable(false);
		elseif CEH.Data.class1.name == class1 and CEH.Data.class2.name == class2 then
			CEH_Change_Button1:Disable()
			CEH_Change_Button1_Left:SetMouseEnable(false);
			CEH_Change_Button1_Right:SetMouseEnable(false);
		elseif CEH.Data.class1.name == class1 and CEH.Data.class3.name == class2 then
			CEH_Change_Button2:Disable()	
			CEH_Change_Button2_Left:SetMouseEnable(false);
			CEH_Change_Button2_Right:SetMouseEnable(false);
		elseif CEH.Data.class2.name == class1 and CEH.Data.class1.name == class2 then
			CEH_Change_Button3:Disable()
			CEH_Change_Button3_Left:SetMouseEnable(false);
			CEH_Change_Button3_Right:SetMouseEnable(false);
		elseif CEH.Data.class2.name == class1 and CEH.Data.class3.name == class2 then
			CEH_Change_Button4:Disable()
			CEH_Change_Button4_Left:SetMouseEnable(false);
			CEH_Change_Button4_Right:SetMouseEnable(false);
		elseif CEH.Data.class3.name == class1 and CEH.Data.class1.name == class2 then
			CEH_Change_Button5:Disable()
			CEH_Change_Button5_Left:SetMouseEnable(false);
			CEH_Change_Button5_Right:SetMouseEnable(false);
		elseif CEH.Data.class3.name == class1 and CEH.Data.class2.name == class2 then
			CEH_Change_Button6:Disable()	
			CEH_Change_Button6_Left:SetMouseEnable(false);
			CEH_Change_Button6_Right:SetMouseEnable(false);		
		end
	end	
end

function CEH.func.ExchangeClass(class1, class2)
	ExchangeClass(class1,class2);
end
	
function CEH.func.SetTooltip(frame,class1,class2)
	GameTooltip:SetOwner(frame, "ANCHOR_LEFT", 4, 0) -- Set Owner --
	GameTooltip:ClearLines() -- Clear tooltip --
	if CEH.Data.class3.name == nil then	
		if class1==1 and class2==0 then
			GameTooltip:AddLine(CEH.Data.class1.name .." " .. CEH.Data.class1.lvl, 0.75, 0.75, 0.75)
		elseif class1==2 and class2==0 then
			GameTooltip:AddLine(CEH.Data.class2.name .." " .. CEH.Data.class2.lvl, 0.75, 0.75, 0.75)
		elseif class1==1 and class2==2 then
			GameTooltip:AddLine(CEH.Data.class1.name .." / " .. CEH.Data.class2.name, 0.75, 0.75, 0.75)
		elseif class1==2 and class2==1 then
			GameTooltip:AddLine(CEH.Data.class2.name .." / " .. CEH.Data.class1.name, 0.75, 0.75, 0.75)
		else
			GameTooltip:AddLine(CEH.Data.name, 0.75, 0.75, 0.75)
		end
	end
	if CEH.Data.class3.name ~= nil then
		if class1==1 and class2==0 then
			GameTooltip:AddLine(CEH.Data.class1.name .." " .. CEH.Data.class1.lvl, 0.75, 0.75, 0.75)
		elseif class1==2 and class2==0 then
			GameTooltip:AddLine(CEH.Data.class2.name .." " .. CEH.Data.class2.lvl, 0.75, 0.75, 0.75)
		elseif class1==3 and class2==0 then
			GameTooltip:AddLine(CEH.Data.class3.name .." " .. CEH.Data.class3.lvl, 0.75, 0.75, 0.75)
		elseif class1==1 and class2==2 then
			GameTooltip:AddLine(CEH.Data.class1.name .." / " .. CEH.Data.class2.name, 0.75, 0.75, 0.75)
		elseif class1==1 and class2==3 then
			GameTooltip:AddLine(CEH.Data.class1.name .." / " .. CEH.Data.class3.name, 0.75, 0.75, 0.75)
		elseif class1==2 and class2==1 then
			GameTooltip:AddLine(CEH.Data.class2.name .." / " .. CEH.Data.class1.name, 0.75, 0.75, 0.75)
		elseif class1==2 and class2==3 then
			GameTooltip:AddLine(CEH.Data.class2.name .." / " .. CEH.Data.class3.name, 0.75, 0.75, 0.75)	
		elseif class1==3 and class2==1 then
			GameTooltip:AddLine(CEH.Data.class3.name .." / " .. CEH.Data.class1.name, 0.75, 0.75, 0.75)
		elseif class1==3 and class2==2 then
			GameTooltip:AddLine(CEH.Data.class3.name .." / " .. CEH.Data.class2.name, 0.75, 0.75, 0.75)	
		elseif class1==0 and class2==0 then
			GameTooltip:SetText("CEH",1,1,1)	
		else
			GameTooltip:AddLine(CEH.Data.name, 0.75, 0.75, 0.75)			
		end
	end
GameTooltip:Show()
end
--[[ slash commands ]]

    SLASH_CEH1 = "/CEH";

SlashCmdList["CEH"] = function(editBox, msg)
	CEH.func.SetHook()
end;