---------------------------------------------------------------------------------------------------------
-- Lootomatic - Locales for ENGLISH Clients
--
-- written by PetraAreon
-- released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
--
-- Get the current version at:   http://rom.curse.com/downloads/rom-addons/details/lootomatic.aspx
----------------------------------------------------------------------------------------------------------
-- Information for translators:
--
--   modified line 42 (RollFrameSave)
--     Changed "Ctrl+Shift+Click" to "Shift+Click"; was too complicated to handle
--   added lines 47-50 (Removed1, Removed2, NotFound1, NotFound2)
--     these contain systemmessages, when an item has been removed from the itemfilter via the DropTab
--   added line 105 (Settings_RollNewStyle)
--     new option in the settingsframe, to write rollresults in lootomatic-style (item - player - result)
--   restructured the syntax of the locales, makes it easier to replace missing strings with fallback
----------------------------------------------------------------------------------------------------------


----------------------------------------------------------------------------------------------------------
---------- Keywords, that can be used in the itemfilter --------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Keywords.none  = "";
Lootomatic.Keywords.quest = "";
Lootomatic.Keywords.craft = "";
Lootomatic.Keywords.rune  = ""; -- Grade of rune gets appended! i.e. "rune1"
Lootomatic.Keywords.ammo  = "";



----------------------------------------------------------------------------------------------------------
---------- Strings that are written in the chatframe -----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Loaded						= ",  \"|cffFFFE80/lootomatic|r\"       .";
Lootomatic.Strings.Updated						= "   <VERSION>,    .";
Lootomatic.Strings.RollChange					= " -     <ROLLSETTING>!";
Lootomatic.Strings.Description					= "Lootomatic    ,   rollsetting, autoloot, Autopass  autogreed.";
Lootomatic.Strings.AddFilter					= "Add ItemFilter";
Lootomatic.Strings.AddQuickFilter1				= "   |cffFFFE80\"<ITEM>\"|r      |cffFFFE80\"<ROLL>\"|r  .";
Lootomatic.Strings.AddQuickFilter2				= "   |cffFFFE80\"<ITEM>\"|r      |cffFFFE80\"<ROLL>\"|r  .";
Lootomatic.Strings.RollFrameSave				= "\n|cff00c0f3Ctrl+Click|r,    .\n|cff00c0f3Shift+Click|r,    .";
Lootomatic.Strings.DropTab1						= "";
Lootomatic.Strings.DropTab2						= "                 ,        . Leftclick      ,        .";
Lootomatic.Strings.Added1						= " \"<ITEM>\"         <SETTINGS>.";
Lootomatic.Strings.Added2						= " \"<ITEM>\"         <SETTINGS>.";
Lootomatic.Strings.Removed1						= " \"<ITEM>\"     .";
Lootomatic.Strings.Removed2						= " \"<ITEM>\"     .";
Lootomatic.Strings.NotFound1					= " \"<ITEM>\"      .";
Lootomatic.Strings.NotFound2					= " \"<ITEM>\"      .";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the minimap menue ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Enabled						= "!";
Lootomatic.Strings.Disabled						= "!";
Lootomatic.Strings.MEnabled						= "";
Lootomatic.Strings.MDisabled					= "";

Lootomatic.Strings.Roll							= "";
Lootomatic.Strings.AutoLoot						= "AutoLoot";
Lootomatic.Strings.AutoPass						= "AutoPass";
Lootomatic.Strings.AutoGreed					= "AutoGreed";
Lootomatic.Strings.RollMessages					= "Rollresults";
Lootomatic.Strings.NoBoss						= "No Bosses";

Lootomatic.Strings.Never						= "";
Lootomatic.Strings.White						= "";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the settingsframe ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Settings						= "";

Lootomatic.Strings.Settings_BootyHeader			= "Lootfenster";
Lootomatic.Strings.Settings_BootyQuest			= "   ";
Lootomatic.Strings.Settings_BootyMove			= "   ";
Lootomatic.Strings.Settings_BootyClose			= "  ";

Lootomatic.Strings.Settings_RollHeader			= " ";
Lootomatic.Strings.Settings_RollTooltips		= " ";
Lootomatic.Strings.Settings_RollQuest			= "     ";
Lootomatic.Strings.Settings_RollPosition		= "";
Lootomatic.Strings.Settings_RollPositionSave	= "";
Lootomatic.Strings.Settings_RollPositionCancel	= "";
Lootomatic.Strings.Settings_RollPositionOkay	= "";
Lootomatic.Strings.Settings_RollPositionReset	= "";
Lootomatic.Strings.Settings_RollPositionTimer	= "";
Lootomatic.Strings.Settings_RollPositionTimerNo	= " ";

Lootomatic.Strings.Settings_DropHeader			= " ";
Lootomatic.Strings.Settings_DropQuest			= "   ";
Lootomatic.Strings.Settings_DropConfirmNo		= "   ";
Lootomatic.Strings.Settings_DropConfirm			= "  <NUM>   ";
Lootomatic.Strings.Settings_DropAmmo			= "<NUM>  = 1 ";
Lootomatic.Strings.Settings_DropTimeoutNo		= "  ";
Lootomatic.Strings.Settings_DropTimeout			= " <NUM> :";

Lootomatic.Strings.Settings_ChatHeader			= " ";
Lootomatic.Strings.Settings_ChatOutput			= "    ";
Lootomatic.Strings.Settings_RollNewStyle		= "Rollresults in Lootomatic-Style";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the itemfilter -------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.ItemFilter					= " ";
Lootomatic.Strings.Itemname						= " ";
Lootomatic.Strings.Looting						= "";
Lootomatic.Strings.Rolling						= "";

Lootomatic.Strings.LootStatus					= { ""," ","","" };
Lootomatic.Strings.RollStatus					= { "","","","","" };



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in tooltips -------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Tooltip_LongText = "\n shift-key,   .";
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemAdd =
	{
	" ",
	"|cff00c0f3Leftclick:|r     \n|cff00c0f3Rightclick:|r     .",
	"\n  ,  ,        .\n\n      ,        .",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemRemove =
	{
	" ,
	"    .",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Itemname =
	{
	" ",
	" ,      .",
	"\n    *   .\n\n       ,   shift-clicking       .",
	"\n     :",
	{"|cffffffaa$"..Lootomatic.Keywords.quest.."\n$"..Lootomatic.Keywords.ammo.."\n$"..Lootomatic.Keywords.craft.."\n$"..Lootomatic.Keywords.rune.."#|r","Questitems\nevery type of ammunition\nCrafting Runes\nRunes with the Tier # (i.e. $"..Lootomatic.Keywords.rune.."1)"},
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Looting =
	{
	" ",
	",    .",
	"\n  \"\"                   .       ,     . \n ,     ,         ,        !",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Rolling =
	{
	" ",
	",    .",
	"\n  \"Manual\"      ,     -  .",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ResizeButton =
	{
	" ",
	"     .",
	};
