
-- Create a copy of the battle table for manipulation.
function WarRecord.DisplayCopyCreate(battle)
	displayData = {battle = {}}
	table.copy(displayData.battle, battle)

	local k, v
	for k, v in pairs(displayData.battle.teamRecord) do
		if (not v.playerRecord) then
			v.playerRecord = {}
		end
	end

	if not (displayData.battle.selfTeamIndex) then
		displayData.battle.selfTeamIndex = 1
	end
	displayData.usIndex = displayData.battle.selfTeamIndex
	if (displayData.usIndex == 1) then
		displayData.enemyIndex = 2
	else
		displayData.enemyIndex = 1
	end

	displayData.usId = displayData.battle.teamRecord[displayData.usIndex].teamId
	displayData.enemyId = displayData.battle.teamRecord[displayData.enemyIndex].teamId

	-- select the same tab as is already in use (which will cause filtering and sorting on the new displayData)
	WarRecord.GuildHouseWarStatusFrameTab_OnClick(PanelTemplates_GetSelectedTab(WarRecordStatusFrame))
end


function WarRecord.FilteredDisplayCreate(teamId)
	local i
	displayFilteredPlayers = {}

	if not (teamId) then
		local k, v, index
		-- dump all players into a flat table
		for k, v in ipairs(displayData.battle.teamRecord) do
			for i = 1, #(v.playerRecord) do
				table.insert(displayFilteredPlayers, {})
				index = #(displayFilteredPlayers)
				table.copy(displayFilteredPlayers[index], v.playerRecord[i])
				-- id the team
				displayFilteredPlayers[index].teamId = k
			end
		end
	else
		table.copy(displayFilteredPlayers, displayData.battle.teamRecord[teamId].playerRecord)

		for i = 1, #(displayFilteredPlayers) do
			-- id the team
			displayFilteredPlayers[i].teamId = teamId
		end
	end
end


function WarRecord.FilteredDisplayFindSelfPlayer()
	displayFilteredPlayers.selfPlayerIndex = nil

	for i = 1, #(displayFilteredPlayers) do
		if (displayFilteredPlayers[i].iIsPlayer) then
			displayFilteredPlayers.selfPlayerIndex = i
			break
		end
	end
end


