
function WarRecord.AddonManagerRegister()
	if AddonManager then
		local addon = {
			name = WarRecord.Locale.ADDON_NAME,
			version = WarRecord.VERSION_STR,
			author = WarRecord.AUTHOR,
			description = WarRecord.Locale.DESCRIPTION,
			icon = "Interface/GuildHouseFrame/GuildHouseWar-State",
			category = "PvP",
			miniButton = WarRecordAddonManagerButton,
			onClickScript = WarRecord.ToggleHistoryFrame
		}

		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon)
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, 
				addon.configFrame, addon.slashCommands, addon.miniButton, addon.onClickScript, addon.version, addon.author)
		end

		WarRecordMinimapButton:Hide()
	end
end

--------------------------------------------------------------------------------

function WarRecord.MinimapButton_OnEnter(frame)
	GameTooltip:SetOwner(frame, "ANCHOR_LEFT", 4, 0)
	GameTooltip:SetText(WarRecord.Locale.ADDON_NAME, 1, 1, 1)
	GameTooltip:AddLine(WarRecord.Locale.DESCRIPTION, 1, 1, 0.7)
	GameTooltip:AddLine(UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95)
	GameTooltip:Show()
end


function WarRecord.MinimapButton_OnLeave(frame)
	GameTooltip:Hide()
end

--------------------------------------------------------------------------------

function WarRecord.AddonManagerButton_OnEnter(frame)
	GameTooltip:SetOwner(frame, "ANCHOR_BOTTOM", 0, 4)
	GameTooltip:SetText(WarRecord.Locale.ADDON_NAME, 1, 1, 1)
	GameTooltip:AddLine(WarRecord.Locale.DESCRIPTION, 1, 1, 0.7)
	GameTooltip:Show()
end


function WarRecord.AddonManagerButton_OnLeave(frame)
	GameTooltip:Hide()
end

--------------------------------------------------------------------------------

function WarRecord.ToggleHistoryFrame()
	if (BattleListFrame:IsVisible()) then
		BattleListFrame:Hide()
	else
		BattleListFrame:Show()
		BattleListFrame:ResetFrameOrder()
	end
end
