SUI_Settings["CraftProgressCheckButton"] = {};

SUI_Mining = {};
SUI_Mining.Name = LIFESKILL_MINING;
SUI_Mining.ID = "MINING";
SUI_Mining.Icon = "interface/icons/item_ore_022";

SUI_Lumbering = {};
SUI_Lumbering.Name = LIFESKILL_WOOD;
SUI_Lumbering.ID = "LUMBERING";
SUI_Lumbering.Icon = "interface/icons/item_lum_029";

SUI_Herblism = {};
SUI_Herblism.Name = LIFESKILL_HERB;
SUI_Herblism.ID = "HERBLISM";
SUI_Herblism.Icon = "interface/icons/item_her_035";

SUI_BlackSmith = {};
SUI_BlackSmith.Name = LIFESKILL_BLACKSMITH;
SUI_BlackSmith.ID = "BLACKSMITH";
SUI_BlackSmith.Icon = "interface/icons/livingskill_01";

SUI_Carpenter = {};
SUI_Carpenter.Name = LIFESKILL_WOODWORKER;
SUI_Carpenter.ID = "CARPENTER";
SUI_Carpenter.Icon = "interface/icons/livingskill_02";

SUI_MakeArmor = {};
SUI_MakeArmor.Name = LIFESKILL_ARMOR;
SUI_MakeArmor.ID = "MAKEARMOR";
SUI_MakeArmor.Icon = "interface/icons/livingskill_03";

SUI_Tailor = {};
SUI_Tailor.Name = LIFESKILL_TAILOR;
SUI_Tailor.ID = "TAILOR";
SUI_Tailor.Icon = "interface/icons/livingskill_04";

SUI_Cook = {};
SUI_Cook.Name = LIFESKILL_COOK;
SUI_Cook.ID = "COOK";
SUI_Cook.Icon = "interface/icons/livingskill_05";

SUI_Alchemy = {};
SUI_Alchemy.Name = LIFESKILL_ALCHEMY;
SUI_Alchemy.ID = "ALCHEMY";
SUI_Alchemy.Icon = "interface/icons/livingskill_06";

SUI_Plant = {};
SUI_Plant.Name = LIFESKILL_PLANT;
SUI_Plant.ID = "PLANT";
SUI_Plant.Icon = "interface/icons/item_pla_050";

SUI_Fishing = {};
SUI_Fishing.Name = LIFESKILL_FISH;
SUI_Fishing.ID = "FISHING";
SUI_Fishing.Icon = "interface/icons/item_fis_006";

SUI_CraftGroups = {
	SUI_BlackSmith,
	SUI_Carpenter,
	SUI_MakeArmor,
	SUI_Tailor,
	SUI_Cook,
	SUI_Alchemy,
	SUI_Mining,
	SUI_Lumbering,
	SUI_Herblism,
	SUI_Plant,
	SUI_Fishing
	};
	
function CraftProgressFrame_OnLoad(this)
	ProgressBar_maxLev = 0;
	this:RegisterEvent("PLAYER_LIFESKILL_CHANGED");
end

function CraftProgressFrame_OnShow(this)
	CraftProgressFrame_DataChanged(this);
end

function CraftProgressFrame_OnEvent(this, event)
	if (event == "PLAYER_LIFESKILL_CHANGED") then
		CraftProgressFrame_DataChanged(this);
	end
end

function CraftProgressFrame_DataChanged(this)
	local id = this:GetID();
	local bar = getglobal(this:GetName());

	local barIconTexture = getglobal(bar:GetName().."IconTexture");
	local barStatusBar = getglobal(bar:GetName().."StatusBar");
	local barStatusBarValue = getglobal(bar:GetName().."StatusBarValue");
	local barStatusBarLevel = getglobal(bar:GetName().."StatusBarLevel");
	
	local group = SUI_CraftGroups[this:GetID()];
		
	local CurValue = GetPlayerCurrentSkillValue(group.ID);
	local MaxValue = GetPlayerMaxSkillValue(group.ID);

	local lv =  math.floor(CurValue);
	local totalExp = (CurValue - lv) * 100;

	if (totalExp > 99.99)then
		totalExp = 99.99;
	end

	local icon = group.Icon;
	local value = string.format("%.2f", totalExp);		
	local level = C_LEVEL..lv;
		
	if (lv > ProgressBar_maxLev) then
		ProgressBar_maxLev = lv;
	end
	
	barIconTexture:SetTexture(icon);
	barStatusBarValue:SetText(value.."%");
	barStatusBarLevel:SetText(level);

	barStatusBar:SetMaxValue(100);
	barStatusBar:SetValue(totalExp);
	
	CraftProgressFrame_Update();
end

function CraftProgressFrameIcon_OnEnter(this)
	local group = SUI_CraftGroups[this:GetParent():GetID()];
	local rank = CCFrame_GetLifeSkillRankString(GetPlayerMaxSkillValue(group.ID));
	GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	GameTooltip:SetText(group.Name, 1, 1, 1);
	GameTooltip:AddLine(string.sub(rank, 2), 1, 1, 1);
	if this:GetParent():GetID() <= 9 then
		GameTooltip:AddLine(SUI_CRAFT_ICON_TIPS, 0, 0.75, 0.95);
	end
			GameTooltip:AddLine(this:GetParent():GetID(), 0, 0.75, 0.95);
end

function CraftProgressFrameIcon_OnClick(this)
	if this:GetParent():GetID() <= 9 then
		if CraftFrame:IsVisible() then
			HideUIPanel(CraftFrame);
		else
			ShowUIPanel(CraftFrame);
			CraftSkillButton_OnClick(this:GetParent())
		end
	end
end

function CraftProgressCheckButton_OnLoad(this)
	local id = this:GetID();
	local name = getglobal(this:GetName());
	local nameText = getglobal(name:GetName().."NameText");
	local group = SUI_CraftGroups[id];
	nameText:SetText(group.Name)
	
	if not SUI_Settings["CraftProgressCheckButton"][id] then
		SUI_Settings["CraftProgressCheckButton"][id] = true;
	end
	this:SetChecked(SUI_Settings["CraftProgressCheckButton"][id]);
end

function CraftProgressCheckButton_OnShow(this)
	local id = this:GetID();
	this:SetChecked(SUI_Settings["CraftProgressCheckButton"][id]);
end

function CraftProgressCheckButton_OnClick(this)
	local id = this:GetID();
	SUI_Settings["CraftProgressCheckButton"][id] = this:IsChecked();
	CraftProgressFrame_Update();
end

function CraftProgressFrame_Update()
	local x = 0;
	local y = 0;
	for i = 1, 11 do 
		local frame = getglobal("CraftingBar"..i)
		if not SUI_Settings["CraftProgressCheckButton"][i] then
			frame:Hide();
		else
			frame:ClearAllAnchors();
			frame:SetAnchor("CENTER", "CENTER", "CraftProgressFrame", x, y);
			frame:Show();
			y = y + 20;
		end
	end
end	