local aggroStringColor = {};
aggroStringColor[1] = {r = 1.00, g = 0.00, b = 0.00};
aggroStringColor[2] = {r = 1.00, g = 0.50, b = 0.00};
aggroStringColor[3] = {r = 1.00, g = 1.00, b = 0.00};
aggroStringColor[4] = {r = 0.50, g = 1.00, b = 0.00};
aggroStringColor[5] = {r = 0.00, g = 1.00, b = 0.00};
aggroStringColor[6] = {r = 0.00, g = 0.50, b = 0.00};

function SUI_AggroFrame_OnLoad(this)
	this:RegisterEvent("UNIT_TARGET_CHANGED");
	this:RegisterEvent("TARGET_HATE_LIST_UPDATED");
	this:RegisterEvent("COMBATMETER_DAMAGE");
	this:RegisterEvent("COMBATMETER_HEAL");
	for i = 1, 6 do
		local aggroString = getglobal("SUI_AggroString"..i);
		aggroString:SetBarColor(aggroStringColor[i].r, aggroStringColor[i].g, aggroStringColor[i].b);
	end
end

function SUI_AggroFrame_OnEvent(this, event)
	if SUI_AggroFrame:IsVisible() then
		SUI_AggroFrame_Update();
	end
end

function SUI_AggroFrame_Update()
	TargetHateListRequest();
	local totalHate = 0;
	local hateList = {};
	for j = 1, 50 do
		local name, hatePoint = GetTargetHateList(j);
		if name then
			totalHate = totalHate + hatePoint;
			hateList[j] = {["name"] = name, ["hatePoint"] = hatePoint};
		else
			break;
		end
	end
	table.sort(hateList, function(a, b) return a["hatePoint"] > b["hatePoint"] end);
	for i = 1, 6 do
		local aggroString = getglobal("SUI_AggroString"..i);
		local aggroStringName = getglobal("SUI_AggroString"..i.."InfoText");
		local aggroStringValue = getglobal("SUI_AggroString"..i.."ValueText");
		if GetTargetHateList(i) then
			aggroString:SetMaxValue(totalHate);
			aggroString:SetValue(hateList[i]["hatePoint"]);
			aggroStringName:SetText(hateList[i]["name"]);
			aggroStringValue:SetText(hateList[i]["hatePoint"].." ("..math.ceil((hateList[i]["hatePoint"] * 100) / totalHate).."%)");
		else
			aggroString:SetValue(0);
			aggroString:SetMaxValue(0);
			aggroStringName:SetText("");
			aggroStringValue:SetText("");
		end
	end
end		
