function SUI_BackPackButton_OnLoad(this)
	this:RegisterForClicks("LeftButton", "RightButton");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_BAG_CHANGED");
end

function SUI_BackPackButton_OnEvent(this, event)
	local current, maxCount = GetBagCount();
	if current == maxCount then
		current = "|cffff0000"..tostring(current).."|r"
	elseif (current / maxCount) >= .9 then
		current = "|cffFF7F00"..tostring(current).."|r"
	else
		current = "|cffffff20"..tostring(current).."|r"
	end
	SUI_BackPackButtonText:SetFontSize(12);
	SUI_BackPackButtonText:SetText(current.."/"..maxCount);
end

function SUI_BackPackButton_OnClick(this, key)
	PlaySoundByPath("sound\\interface\\ui_generic_click.mp3");
	if key == "RBUTTON" then
		if ItemDurableFrame:IsVisible() then
			ItemDurableFrame:Hide();
		else
			ItemDurableFrame:Show();
		end
	else
		ToggleBackpack();
	end
end

function SUI_BackPackButton_OnEnter(this)
	local text = BACKPACK;
	local key1, key2 = GetBindingKey("TOGGLEBACKPACK");
	if ( key1 ) then
		text = text.."("..key1..")";
	end
	local duraString = SUI_DURABLE_VALUE..": "..SUI_DurableValue().."%"
	GameTooltip:SetOwner(this, "ANCHOR_TOP", 0, 0);
	GameTooltip:SetText(text, 1, 1, 1);
	GameTooltip:AddLine(duraString, 1, 1, 0);
	GameTooltip:AddLine(SUI_DURABLE_TIPS, 0, 0.75, 0.95);
end

function SUI_DurableValue()
	local totalpar = 0
	local count = 0
	for i = 0, 16 do
		if i ~= 9 then
			local durableValue, durableMax = GetInventoryItemDurable("player", i);
			if durableMax > 0 then
				local par = durableValue / durableMax * 100
				totalpar = totalpar + par
				count = count + 1
			end
		end
	end
	local durableTotal = tostring(math.floor(totalpar / count))
	return durableTotal
end

function SUI_MB_ItemCountFrame_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("PLAYER_BAG_CHANGED")
	this:RegisterEvent("MAGICBOX_CHANGED")
end

function SUI_MB_ItemCountFrame_OnEvent(this, event)
	local itemCount = 0
	for i = 51, 55 do
		local icon, name, count, locked = GetGoodsItemInfo(i)
		if name ~= "" then
			itemCount = itemCount + 1
		end
	end
	SUI_MB_ItemCountFrameText:SetText(itemCount.."/5")
end