--  ****************************************
--  **    ntBuff by Tetty(TBD)            **
--  **    re-coded from nuBuff/nBuff      **
--  **    by Roukard, Dinalisa,           **
--  **                Noktrin and ZsZso   **
--  ****************************************
ntbVersion = "1.35"

-- for patch3.0.3
-- if not os then
	-- os={}
-- end
-- if not os.time then 
	-- os.time=function()
		-- return GetTime()
	-- end
-- end
-- if not os.difftime then
	-- os.difftime = function(x, y)
		-- return x-y
	-- end
-- end
--

local lastHeal = 0;
local lastHeal2 = 0;
local lastCombat = 0;
local lastCombatFalse = 0;

-- last time there were ran
local lastUpdate = GetTime();
local lastOnUpdate =GetTime();
local lastResurrect = GetTime();
local lastLoadingStart = GetTime();
local lastLoadingEnd = GetTime();

local lastCombatEnd =GetTime();

-- flags
local alive = true;
local casting = false; -- casting flag
local ntbWarning =false; -- warning flag
local combat = false; -- combat flag
local combatCast = false;
local postCombat =false;
local ntb_loading =true; -- loading flag
local resurrecting = false; -- resurrection flag
local ntBuffReady = false; 
local ntbPlayerState="resting";
local ntbVariablesLoaded=false;
local ntbEmergency=false;
local hideFocus=true;
local ntbPause=false;
local ntbInitialized=false;

-- constants

local updateInt = 0.5; -- How often the script runs functions
local loadTime = 1; -- Maximum loading time
local waitAfterResurrect = 5; -- Waiting time after resurection 
local waitAfterLoading =1; -- Wainting Time after loading end
local statusUpdateInterval = 0.3; 
local GCthreshold = 80000; -- Threshold for garbage collection in KB
-- 
local b1c = false;
local b2c = false;
local b3c = false;
local hps = 50000;
local InitPlayerName = "TBD"; -- Hi!
local InitClass = "temp";
local playerName = InitPlayerName;
local class = InitClass;
local previousIcon1="";
local previousIcon2="";
--
local hpr=0; -- Player's HP in percent
--
local ntbNumberOfHealthPots = 5; -- number of HP pots
local ntbNumberOfManaPots = 5; -- number of MP pots
local ntbNumberOfBuffs = 12; -- number of Buffs
local ntbChkInterval=39; --39 means off

-- skill icon names for mount/hide check
local ntb_MountOrHide ={
	"charger",       -- some mounts in shop & bag
	"mount",         -- most mounts in shop item
	"thanksgiving_10",
	"skill_kni59%-1", -- horse
	"skill_thi3%-2",  -- Rogue skill hide
	"skill_thi54%-1"  -- Rogue skill vanish
}

-- read language file
do
	local curLocal = string.sub(GetLanguage():upper(), 1,2);
	local localeFileName = "Interface/AddOns/ntBuff/locales/ntBuff."..string.upper(curLocal)..".lua";
	--DEFAULT_CHAT_FRAME:AddMessage(localeFileName.." to load");
	local func, err = loadfile(localeFileName);
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(err));
	if (err) then
		dofile("Interface/AddOns/ntBuff/locales/ntBuff.EN.lua");
		--DEFAULT_CHAT_FRAME:AddMessage("EN loaded");
	else
		dofile(localeFileName);
		--DEFAULT_CHAT_FRAME:AddMessage(localeFileName.."loaded");
	end
end


local ntbDefault = {
				["ver110"]=true,
				
				["enabled"] = true,
				["alertDuration"] = 15,
				["HPfirstMode"]=false,
				["HPemergency"]=25,
				["HPsafe"]=75,
				
				["chkIntR"]=19;
				["chkIntA"]=7;
				["chkIntC"]=1;
				
				
				-- ||||| Heal |||||
				["uPot"] = false,
				["uPotSlot"] = 0,
				["uPotRate"] = 0,
				["castUltimate"] = false,
				["uSlot"] = 0,
				["uCastRate"] = 0,
				["castHeal"] = false,
				["hRate1"] = 0,
				["healSlot1"] = 0,
				["castHeal2"] = false,
				["hRate2"] = 0,
				["healSlot2"] = 0,
				
				["Equipment1"]=false,
				["Equipment1Slot"]=2,
				["Equipment1Rate"]=10,
				["Equipment2"]=false,
				["Equipment2Slot"]=1,
				["Equipment2Rate"]=50,
				

				--other config
				["PvPmode"]=false,
				["PTmode"]=false,
				-- ["chkInt"]=updateInt,
				-- ["LoadingTime"]=loadTime,
				-- ["CDafterLoading"]=waitAfterLoading,
				-- ["CDafterResurrect"]=waitAfterResurrect
				["hideFocus"]=true;
				["hideButton"]=false;
			};
do
	for i=1, ntbNumberOfHealthPots do
		ntbDefault["hPotSlot"..i] = 0;
		ntbDefault["hPotEn"..i] = false;
		ntbDefault["hPotRate"..i] = 0;
	end
	for i=1, ntbNumberOfManaPots do
		ntbDefault["mPotSlot"..i] = 0;
		ntbDefault["mPotEn"..i] = false;
		ntbDefault["mPotRate"..i] = 0;
	end
	for i=1, ntbNumberOfBuffs do
		ntbDefault["entBuff"..i] = false;
		ntbDefault["cBuff"..i] = false;
		ntbDefault["aBuff"..i] = false;
		ntbDefault["rBuff"..i] = false;
		
		ntbDefault["bslot"..i] = 0;
	end	
end


--
function ntBuff_OnLoad(this)
	-- this:RegisterEvent("BILLBOARD_CLOSE");
	-- this:RegisterEvent("CHAT_MSG_COMBAT");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CASTING_START");
	this:RegisterEvent("CASTING_STOP");
	this:RegisterEvent("CASTING_FAILED");
	--this:RegisterEvent("CASTING_DELAYED");
	this:RegisterEvent("WARNING_START");
	this:RegisterEvent("WARNING_STOP");
	-- this:RegisterEvent("UNIT_HEALTH");
	-- this:RegisterEvent("PLAYER_ENTER_COMBAT");
	-- this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("PLAYER_ALIVE");
	this:RegisterEvent("ZONE_CHANGED");
	this:RegisterEvent("COUNTDOWN_END");
	this:RegisterEvent("LOADING_END");
	-- this:RegisterEvent("UNIT_BUFF_CHANGED");
	-- this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("EXCHANGECLASS_SUCCESS");
	this:RegisterEvent("FOCUS_CHANGED");
	
	SaveVariables("ntBuff");

end

function ntbInitializeLocalVars()
	ntBuff_chkVarLoaded();
	lastHeal = 0;
	lastHeal2 = 0;
	lastCombat = 0;
	lastCombatFalse = 0;
-- last time there were ran
	lastUpdate = GetTime();
	lastResurrect = GetTime();
	lastLoadingStart = GetTime();
	lastLoadingEnd = GetTime();
	lastCombatEnd =GetTime();
	lastOnUpdate =GetTime();
-- flags
	alive = true;
	casting = false; -- casting flag
	combat = false; -- combat flag
	combatCast = false;
	postCombat =false;
	ntb_loading =false; -- loading flag
	resurrecting = false; -- resurrection flag
	ntBuffReady = true; 
end


function ntBuff_OnEvent(this, event, arg1, arg2 )
	if ( event == "VARIABLES_LOADED" ) then
		if(not ntBuff) then
			ntBuff = {};
			ntBuff["debug"] = "test";
		end
		ntBuff_AddonManager();
		ntbInitializeLocalVars();
		ntBuff_chkVarLoaded();
		ntbVariablesLoaded=true;
		ntbInitialized=true;
	elseif ( event == "CASTING_START" ) then
		casting = true;
	elseif ( event == "CASTING_STOP" ) then
		casting = false;
	elseif ( event == "CASTING_FAILED" ) then
		casting = false;
	elseif ( event == "WARNING_START" ) then
		ntbWarning = true;
	elseif ( event == "WARNING_STOP" ) then
		ntbWarning = false;
	
	-- elseif ( event == "UNIT_HEALTH" and arg1 == "player" ) then
		-- hps = arg2;
		-- ntBuff_tryBuff();
	-- elseif (event == "CHAT_MSG_COMBAT" and GetPlayerCombatState()) then
		-- if ntBuffReady then ntBuff_tryBuff(); end

	-- elseif ( event == "PLAYER_ENTER_COMBAT" ) then
		-- ntBuff_checkCombat();
	-- elseif ( event == "PLAYER_LEAVE_COMBAT" ) then
		-- ntBuff_checkCombat();
	elseif ( event == "PLAYER_DEAD" ) then
		alive = false;
		resurrecting = false;
		combat = false;
	elseif ( event == "PLAYER_ALIVE" ) then
		alive = true;
		lastResurrect = GetTime();
		resurrecting = true;
	elseif (event=="COUNTDOWN_END") then
		lastLoadingStart=GetTime();
		ntb_loading =true;
	elseif (event =="LOADING_END" or event =="ZONE_CHANGED") then
		if not ntbInitialized then
			if(not ntBuff) then
				ntBuff = {};
				ntBuff["debug"] = "test";
			end
			ntBuff_AddonManager();
			ntbInitializeLocalVars();
			ntBuff_chkVarLoaded();
			ntbVariablesLoaded=true;
			ntbInitialized=true
		end
	
		ntBuff_loadingEnd()
		ntbGC_FullGC()
	elseif (event =="EXCHANGECLASS_SUCCESS") then
		ntBuff_loadingEnd()
		ntbGC_FullGC()
	elseif ( event =="FOCUS_CHANGED" and hideFocus) then
		FocusFrame:Hide();
	else
		--ntBuff_tryBuff();
	end
end

function ntBuff_loadingEnd()
	if not LoadingFrame:IsVisible() then
		--DEFAULT_CHAT_FRAME:AddMessage(ntbTestText);
		--ntbTestText="";
		ntbVariablesLoaded=false;
		-- if not ntBuff["GCnonCombat"] then ntBuff["GCnonCombat"]=80 end
		-- if not combat and ntBuff["GCnonCombat"]<80 then
			-- local oldMemLoad = collectgarbage("count");
			-- if oldMemLoad>ntBuff["GCnonCombat"]*1000 then
				-- collectgarbage("collect")
				-- if ntBuff["GCdebug"] then
					-- DEFAULT_CHAT_FRAME:AddMessage("Full GC: "..tostring(math.floor(((oldMemLoad-collectgarbage("count"))/1024*10)+0.5)/10).." MB released.");
				-- end
			-- end
		-- end
		ntBuff_chkVarLoaded();
		ntBuff.GCenable=true;
	end
end
local numTriggeringFrame=200
local frameWidth=5
function ntBuff_PositionTriggeringFrames(sens)
	local scale=GetUIScale()
	local width, height = UIParent:GetSize()
	if not sens then sens=50 end
	if sens<40 then sens=40 end
	local xnum=math.floor(width/sens)
	if xnum>100 then xnum=100 end
	local ynum = math.floor(height/sens)
	if ynum>100 then ynum=100 end
	numTriggeringFrame=xnum+ynum
	for i=0, 199 do
		local frame=_G["ntBuff_Trigger_Frame"..i]
		frame:ClearAllAnchors();
		if i< xnum + 1 then
			frame:SetAnchor("CENTER","CENTER","UIParent",0, (i-xnum/2+ ntb_random())*sens/scale);
			frame:SetSize(width/scale,frameWidth/scale)
			frame:Show()
		elseif i<numTriggeringFrame then
			frame:SetAnchor("CENTER","CENTER","UIParent",(i-xnum-ynum/2+ ntb_random())*sens/scale, 0);
			frame:SetSize(frameWidth/scale,height/scale)
			frame:Show()
		else 
			frame:Hide()
		end
	end
end
local iteration=4
function ntb_random()
	local result=0
	for i=1, iteration do 
		result=result+math.random()
	end
	return (result/iteration-0.5)*2
end

function ntBuff_ShowTriggeringFrames()
	ntBuff_PositionTriggeringFrames(ntBuff[playerName..class]["MouseSens"])
	-- for i=0, numTriggeringFrame -1 do
		-- local frame=_G["ntBuff_Trigger_Frame"..i]
		-- frame:Show();
	-- end
end

function ntBuff_HideTriggeringFrames()
	for i=0, numTriggeringFrame -1 do
		local frame=_G["ntBuff_Trigger_Frame"..i]
		frame:Hide();
	end
end


function ntBuff_chkTiming(now)
	if not ntbChkInterval then 
		ntbChkInterval=1
	end
	if not UnitName("player") then return false; end
	if (UnitHealth("player")<=0) then return false; end
	if (ntbChkInterval>=39) then return false; end
	if (now - lastUpdate) < (ntbChkInterval+1)*0.25  then return false; end
	if (now - lastResurrect) < waitAfterResurrect then return false; end
 	if (now - lastLoadingEnd) < waitAfterLoading then return false; end
	if (now - lastLoadingStart) < loadTime then return false; end
	
	if LoadingFrame:IsVisible() then 
		ntb_loading = true;
		return false;
	else
		if ntb_loading then
			ntBuff_loadingEnd()
		end
		ntb_loading = false
		if (alive) then return true; else return false; end
	end
end

local VaranasZoneID = 10000
local ObsidianZoneID =10001
local myHouseZoneID = 400
local GuildCastleZoneID =401

function ntBuff_chkLocation()
	
	local currentZoneID = GetCurrentWorldMapID();
	if (currentZoneID == myHouseZoneID or currentZoneID == GuildCastleZoneID) then
		return false;
	elseif (ntBuff[playerName..class]["PvPmode"]) then
		return true;
	else
		if (currentZoneID == VaranasZoneID or currentZoneID==ObsidianZoneID) then
			return false;
		else
			return true;
		end
	end
end

function ntBuff_chkPT()
	if (ntBuff[playerName..class]["PTmode"] and GetNumPartyMembers()>0) then
		return true;
	else
		return false;
	end
end

function ntBuff_tryBuff()
	local casted=false;
	if ntBuffReady and ntBuff_chkTiming(GetTime()) then
		ntBuffReady = false;
		
		if (playerName~=UnitName("player") or class~=UnitClass("player")) then 
			ntBuff_chkVarLoaded(); 
			ntBuffReady=true
			return false
		end
		
		if (ntBuff_chkLocation() and ntBuff[playerName..class]["enabled"]) then
			if (not ntBuff_isMounted()) then
				casted= ntBuff_checkStats();
				if (not casted) and (not ntbPause) and (not ntBuff_chkPT()) then 
					casted=ntBuff_checkBuff(); 
				end				
			end
		end
		
		lastUpdate = GetTime();
		ntBuffReady = true;
	end
	return casted
end

function ntBuff_chkVarLoaded()
	playerName = UnitName("player"); 
	if not playerName then playerName=InitPlayerName; end
	
	class = UnitClass("player"); 
	if not class then class=InitClass; end
	
	-- check if savedVariables has been loaded already
	if not ntBuff then
		ntBuff={}
	end
	if (not ntBuff[playerName..class] or not ntBuff[playerName..class]["ver110"]) then
		DEFAULT_CHAT_FRAME:AddMessage("Configuration cleared. Type /ntb for new setting.");
		ntBuff[playerName..class]={}
		for key,value in pairs(ntbDefault) do
		  ntBuff[playerName..class][key] = value
		end
		ntBuff[playerName..class]["HookMouse"]=true
		ntBuff[playerName..class]["MouseSens"]=50
		ntBuff[playerName..class]["HookMovement"]=true
		ntBuff[playerName..class]["ver130"]=true
		if playerName~=InitPlayerName then ntBuff_openConfig(); end 
		--DEFAULT_CHAT_FRAME:AddMessage("player loaded");
						
	end

	-- if (not ntBuff[playerName..class]["chkInt"]) then
		-- ntBuff[playerName..class]["chkInt"]=updateInt;
	-- end
	-- if (not ntBuff[playerName..class]["LoadingTime"]) then
		-- ntBuff[playerName..class]["LoadingTime"]=loadTime;
	-- end
	-- if (not ntBuff[playerName..class]["CDafterLoading"]) then
		-- ntBuff[playerName..class]["CDafterLoading"]=waitAfterLoading;
	-- end
	-- if (not ntBuff[playerName..class]["CDafterResurrect"]) then
		-- ntBuff[playerName..class]["CDafterResurrect"]=waitAfterResurrect;
	-- end
	hideFocus=ntBuff[playerName..class]["hideFocus"];
	if(ntBuff[playerName..class]["hideButton"]) then
		ntBuff_Status:Hide();
	else
		ntBuff_Status:Show();
	end
	
	if not ntBuff[playerName..class]["ver130"] then
		if playerName~=InitPlayerName then DEFAULT_CHAT_FRAME:AddMessage("ntBuff: Type /ntb to set triggering conditions.") end
		ntBuff[playerName..class]["HookMouse"]=true
		ntBuff[playerName..class]["MouseSens"]=50
		ntBuff[playerName..class]["HookMovement"]=true
		ntBuff[playerName..class]["ver130"]=true
		SaveVariables("ntBuff");
	end
	if playerName~=InitPlayerName and class~=InitClass then
		ntbVariablesLoaded=true
		lastLoadingEnd=GetTime();
		ntb_loading = false;
		ntBuff_PositionTriggeringFrames(ntBuff[playerName..class]["MouseSens"])
	else
		ntbVariablesLoaded=false
	end
end

-- local ntbGCthreshold=0
-- local lastGC=GetTime()
-- function ntBuff_collectGarbage()
	-- local i=0
	-- local oldMem = collectgarbage("count")
	-- local currMem = oldMem
	-- while i<10 and currMem>ntbGCthreshold do
		-- i = i+1
		-- collectgarbage ("step", 10);
		-- currMem = collectgarbage("count")
	-- end
	-- lastGC=math.floor((GetTime()-lastGC)/60);
	-- if i>0 then 
		-- ChatFrame3:AddMessage (lastGC..":GC done ... ".. i .."steps to free "..math.floor((oldMem-currMem)/1000).."MB") 
	-- end
	-- if currMem>ntbGCthreshold then
		-- ntbGCthreshold = currMem
	-- else 
		-- ntbGCthreshold = (currMem + ntbGCthreshold) /2
	-- end
	-- ChatFrame3:AddMessage (lastGC..":GC threshold is now ".. math.floor(ntbGCthreshold/1000).."MB") 
	-- lastGC=GetTime()
-- end

local iconPath="Interface/AddOns/ntBuff/img/"
local nextIcon1=""
local ntb_TriggerIcon="OFF"
local ntb_TriggerTime=GetTime()

function ntBuff_OnUpdate()
	if ntBuffReady and ntBuff_chkTiming(GetTime()) then
		if ntb_TriggerIcon=="ON" then
			ntb_Trigger:SetFile("Interface/AddOns/ntBuff/img/LEDOFF.png")
			ntb_TriggerIcon="OFF"
			if ntBuff and ntBuff[playerName..class]["HookMouse"] then
				ntBuff_ShowTriggeringFrames()
			end
		end
	elseif ntb_TriggerIcon=="OFF" then
		ntb_Trigger:SetFile("Interface/AddOns/ntBuff/img/LEDON.png")
		ntb_TriggerIcon="ON"
		if ntBuff and ntBuff[playerName..class]["HookMouse"] then
			ntBuff_HideTriggeringFrames()
		end		
	end

	if ((GetTime()-lastOnUpdate) > statusUpdateInterval) then
		if not ntbVariablesLoaded or playerName==InitPlayerName or class==InitClass or playerName~=UnitName("player") or class~=UnitClass("player") then
			ntBuff_chkVarLoaded()
			return
		end
			
		if LoadingFrame:IsVisible() then 
			ntb_loading = true;
		else
			if ntb_loading then
				ntBuff_loadingEnd()
			end
			ntb_loading = false
		
			ntBuff_checkCombat();
			ntBuff_checkEmergency();
			nextIcon1="";
			if ntBuff[playerName..class]["enabled"] and ( not ntbPause ) then
				if ntBuffReady then
					if ntbEmergency then
						nextIcon1="emergency.png";
					else
						nextIcon1="ntBuff.png";
					end
				else
					nextIcon1="ntBuff2.png";
				end	
			else
				nextIcon1="disabled.png";
			end
			if (previousIcon1=="" or previousIcon1~= nextIcon1) then
				ntb_ExecIcon:SetFile(iconPath..nextIcon1);
			end
			
			if not combat and ntBuff.GCenable then
				ntbGC_stepGC()
			end
			
			if not ntBuff["GCnonCombat"] then ntBuff["GCnonCombat"]=80 end
			if not ntBuff["GCcombat"] then ntBuff["GCcombat"]=80 end
			
			if (ntBuff["GCnonCombat"]<80 and not combat and collectgarbage("count")> ntBuff["GCnonCombat"]*1000) then 
				ntbGC_FullGC()
			elseif (ntBuff["GCcombat"]<80 and combat and collectgarbage("count")> ntBuff["GCcombat"]*1000) then
				ntbGC_FullGC()
			end
			
			if ntBuff[playerName..class]["enabled"] and ntBuffReady then
				ntBuff_SwapEquipment()
			end
			

			
			previousIcon1=nextIcon1;
			lastOnUpdate=GetTime();
		end
	end
end

function ntBuff_checkEmergency()
	hpr = UnitHealth("player")/UnitMaxHealth("player")*100
	
	if (hpr<= ntBuff[playerName..class]["HPemergency"]) then 
		ntbEmergency=true;
		--if ntBuff[playerName..class]["HPfirstMode"] then ntb_State:SetColor(1,0,0); end
	end
	
	if (hpr>= ntBuff[playerName..class]["HPsafe"]) then 
		ntbEmergency=false;
		--ntb_State:SetColor(0,1,0);
	end
end
	
function ntBuff_forceAlertMode()
	ntBuff[playerName..class]["enabled"]=true;
	ntbPause=false;
	combat=true;
	ntBuff_checkCombat();
end

local nextIcon2=""
function ntBuff_checkCombat()
	nextIcon2="resting.tga";
	
	if (GetPlayerCombatState()) then -- during combat
		combat = true;
		ntbPlayerState="combat";
		nextIcon2="combat.tga";
		ntbChkInterval=ntBuff[playerName..class]["chkIntC"];
	elseif (combat==true) then -- just when combat ends
		combat = false;
		lastCombatEnd=GetTime();
		postCombat=true;
		ntbPlayerState="alert";
		nextIcon2="alert.tga";
		ntbChkInterval=ntBuff[playerName..class]["chkIntA"];

	elseif postCombat and (GetTime() - lastCombatEnd <ntBuff[playerName..class]["alertDuration"]) then
	-- within duration after last combat ends
		ntbPlayerState="alert";
		nextIcon2="alert.tga";
		ntbChkInterval=ntBuff[playerName..class]["chkIntA"];
	else
	-- otherwise return to resting state
		postCombat = false;
		ntbPlayerState="resting";
		nextIcon2="resting.tga";
		ntbChkInterval=ntBuff[playerName..class]["chkIntR"];
	end
	
	if ntBuff_isMounted() then
		combat = false;
		postCombat=false;
		ntbPlayerState="mount";
		nextIcon2="mount.tga";
	end
	
	if casting then
		ntbPlayerState="casting";
		nextIcon2="casting.tga";
	end
	
	if ntbWarning then
		ntbPlayerState="warning";
		nextIcon2="warning.tga";
	end
	
	if (previousIcon2=="" or previousIcon2~= nextIcon2) then
		ntb_StateIcon:SetFile(iconPath..nextIcon2);
	end
	previousIcon2=nextIcon2;
end


-- Check for mount and buff
function ntBuff_isMounted()
	local buffID = 0;
	local i=1;
	local buffName, buffIcon, buffCount = UnitBuff("player",i);
	while(buffName) do
		buffName, buffIcon, buffCount = UnitBuff("player",i);
		if (buffIcon) then
			buffIcon=tostring(buffIcon);
			-- DEFAULT_CHAT_FRAME:AddMessage(buffIcon);
			for key, value in pairs(ntb_MountOrHide) do
				if (string.find (buffIcon, ntb_MountOrHide[key]) ~= nil) then
					buffID = i;
				end
			end
		end
		i=i+1;
	end
	-- if buffID>0 then 
		-- DEFAULT_CHAT_FRAME:AddMessage("MOUNT or HIDE");
	-- end
	
	return buffID > 0;
end

-- -----------------------------------------------------Start Buff Functions ----------------------------------------
-- Check if player has a buff

local graceOfLife = "skill_aug21%-2"
local enhancedGraceOfLife = "skill_aug_new20%-3";
local angelsBlessing = "skill_aug_new20%-2";
local quicknessAura ="skill_thi_new15%-2";
local evasionBuff ="skill_thi72%-1";
local luckPotionBuff ="item_her_039";
local luckPotion ="item_potion_040_004";

function ntBuff_hasBuff(slot)
	local iconID = GetActionInfo(slot);
	if (not iconID) then iconID=""; end
	if string.find(iconID, luckPotion) then iconID=luckPotion end
	
	-- you cannot use skill name, because GetActionInfo returns "" for skills
	-- so use icon name instead
	-- DEFAULT_CHAT_FRAME:AddMessage("buff to cast: "..iconID)
	local buffID = 0;
	local i=1;
	local buffIcon 	
	while( UnitBuff("player", i) ~= nil ) do
		_, buffIcon = UnitBuff("player", i);
		if (not buffIcon) then buffIcon=""; end
		if string.find(buffIcon, luckPotionBuff) then buffIcon=luckPotion end

		if (buffIcon == iconID) then
		-- if the same buff remains (check by icon)
			if UnitBuffLeftTime("player", i)>(ntbChkInterval+1)*0.5 then
			-- if the duration of the buff is long enough 
				buffID =i;
			end
		elseif (string.find(iconID, graceOfLife) and string.find(buffIcon, enhancedGraceOfLife)) then
		-- if player has enhanced GraceOfLife, and s/he tries to cast graceOfLife
			buffID =i;
		elseif (string.find(iconID, quicknessAura) and string.find (buffIcon, evasionBuff)) then
		-- if player has evasionBuff and s/he tries to cast quickness aura
			buffID =i;
		end	

		i=i+1;
	end
	return buffID > 0;
end

function GetActionName(pos)
	GameTooltip:SetActionItem(pos)
	GameTooltip:Hide()
	local tmp = GameTooltipTextLeft1:GetText()
	if string.find(tmp, "+") then
		return 	string.sub(tmp, 1, string.find(tmp, "+")-1)
	else
		return tmp
	end
		
end

function ntBuff_hasBuffbyName(slot)
	local name = GetActionName(slot);
	if (not name) then name=""; end

	local buffID = 0;
	local i=1;
	local buffName 	
	while( UnitBuff("player", i) ~= nil and buffID==0) do
		buffName = UnitBuff("player", i);
		if (not buffName) then buffName=""; end

		if (buffName == name) then
		-- if the same buff remains (check by icon)
			if UnitBuffLeftTime("player", i)>(ntbChkInterval+1)*0.5 then
			-- if the duration of the buff is long enough 
				buffID =i;
			end
		end	
		i=i+1;
	end
	return buffID > 0;
end

function ntBuff_CancelBuff(slot)
	local iconID = GetActionInfo(slot);
	if (not iconID) then iconID=""; end
	local i=1;
	local buffIcon 	
	while( UnitBuff("player", i) ~= nil ) do
		_, buffIcon = UnitBuff("player", i);
		if (not buffIcon) then buffIcon=""; end

		if (buffIcon == iconID) then
			CancelPlayerBuff(i)
		end
		i=i+1;
	end
end




-- Cast this buff
function ntGetAvailableFocusID()
	for i = 1 , 12 , 1 do
		if ( not UnitExists( "focus"..i ) ) then
			return i;
		end
	end
end

function ntDoAction(pos)
	local focusID = ntGetAvailableFocusID();
	local noTarget=false;
	if not UnitExists("target") then 
		noTarget=true;
		TargetUnit("player"); 
	end
	FocusUnit( focusID, "target");
	TargetUnit("player");
	UseAction(pos);		
	if noTarget then
		TargetUnit("");
	else
		TargetUnit( "focus"..tostring(focusID) );
	end
	FocusUnit(focusID, "");
	if (hideFocus) then
		FocusFrame:Hide();
	end
end


function ntBuff_doBuff(slot)
	local _,_, count = GetActionInfo(slot);
	local _, remaining = GetActionCooldown(slot);
	if not count then count = 0 end
	if (count>0 and (not ntBuff_hasBuff(slot)) and GetActionUsable(slot) and remaining <0.05) then
		ntDoAction(slot);
		return true;
	else
		return false;
	end
end

function UseBagItemByName(item)
	local index, name
	for i=1, 180 do
		index, _, name = GetBagItemInfo(i)
		if name then
			if name==item then
				UseBagItem(index)
				return true
			end
		end
	end
	return false
end


function ntBuff_usePot(slot)
	local _,_, count = GetActionInfo(slot);
	local _, remaining = GetActionCooldown(slot);
	local name = GetActionName(slot)
	if not count then count = 0 end
	if (count>0 and GetActionUsable(slot) and remaining <0.05) then
		UseAction(slot)
		return true;
	else
		return false;
	end
end

function ntBuff_canBuff() 
	local _, _, currValue =  UnitCastingTime("player");
	if casting then return false;
	elseif ntbWarning then return false;
	elseif (not currValue) then return false;
	elseif (currValue>0.05) then return false;
	elseif (not ntBuff[playerName..class]["enabled"]) then return false;
	elseif ntBuff_isMounted() then return false;
	elseif not alive then return false;
	else return true;
	end
end

-- Main buff function
function ntBuff_checkBuff() 
	-- DEFAULT_CHAT_FRAME:AddMessage("canBuff(): "..tostring(ntBuff_canBuff()));
	-- DEFAULT_CHAT_FRAME:AddMessage("combat: "..tostring(combat));
	-- DEFAULT_CHAT_FRAME:AddMessage("postCombat: "..tostring(postCombat));
	
	if ntBuff_canBuff() then
		local prefix ="r";
		if (ntbPlayerState=="combat") then prefix="c";
		elseif (ntbPlayerState=="alert") then prefix="a";
		else prefix="r";
		end
		
		local i=1;
		local notBuffExec=true;
		while (i<=ntbNumberOfBuffs and notBuffExec) do
			if (ntBuff[playerName..class]["entBuff"..i] and ntBuff[playerName..class][prefix.."Buff"..i]) then
				if (ntBuff[playerName..class]["bslot"..i]~=nil) then
					notBuffExec= not ntBuff_doBuff(ntBuff[playerName..class]["bslot"..i]);
				end
			end
			i=i+1;
		end
	end
	return (not notBuffExec)
end

function ntBuff_getCd(slot) 
	local x, y = GetActionCooldown(slot);
	return y;
end

-- End Buff

--[[ |||||Pot vars|||||
					-- health
					["hPotSlot1"] = 0,
					["hPotSlot2"] = 0,
					["hPotEn1"] = true,
					["hPotEn2"] = false,
					["hPotRate1"] = 0,
					["hPotRate2"] = 0,
					-- mana
					["mPotSlot1"] = 0,
					["mPotSlot2"] = 0,
					["mPotEn1"] = false,
					["mPotEn2"] = true,
					["mPotRate1"] = 0,
					["mPotRate2"] = 0,
]]

local mpr=0
function ntBuff_pot() 
	hpr = UnitHealth("player")/UnitMaxHealth("player")*100;

	if UnitManaType("player")~=1 and UnitSkillType("player")==1 then
		mpr=UnitSkill("player")/UnitMaxSkill("player")*100;
	else
		mpr=UnitMana("player")/UnitMaxMana("player")*100;
	end
				
	-- Health potions
	local i=1;
	local notPotUsed=true; -- flag to ignore all remaining pots after first successful pot use
	while (i<=ntbNumberOfHealthPots and notPotUsed) do 
	-- for i=1, ntbNumberOfHealthPots do
		if(hpr < ntBuff[playerName..class]["hPotRate"..i] and ntBuff[playerName..class]["hPotEn"..i]) then
			if (ntBuff[playerName..class]["hPotSlot"..i]) then
				notPotUsed= not ntBuff_usePot(ntBuff[playerName..class]["hPotSlot"..i]);
			end
		end
		i=i+1;
	end
	
	-- Mana potions:
	if not (ntbEmergency and ntBuff[playerName..class]["HPfirstMode"]) then
		-- for i = 1, ntbNumberOfManaPots do
			-- if(mpr < ntBuff[playerName..class]["mPotRate"..i])then		
				-- if(ntBuff[playerName..class]["mPotEn"..i] == true) then
					-- if(ntBuff_getCd(ntBuff[playerName..class]["mPotSlot"..i]) < 0.05) then
						-- ntBuff_doBuff(ntBuff[playerName..class]["mPotSlot"..i]);
					-- end
				-- end
			-- end
		-- end
		i=1;
		while (i<=ntbNumberOfManaPots and notPotUsed) do 
			if(mpr < ntBuff[playerName..class]["mPotRate"..i] and ntBuff[playerName..class]["mPotEn"..i]) then
				if (ntBuff[playerName..class]["mPotSlot"..i]) then
					notPotUsed= not ntBuff_usePot(ntBuff[playerName..class]["mPotSlot"..i]);
				end
			end
			i=i+1;
		end
	end
	return (not notPotUsed)
end

function ntBuff_AdvPot()
	-- HP
	hpr = UnitHealth("player")/UnitMaxHealth("player")*100;
	local prefix;
	if (ntbPlayerState=="combat") then 
		prefix="c";
	elseif (ntbPlayerState=="alert") then 
		prefix="a";
	else 
		prefix="r";
	end
	
	local i=1;
	local notPotUsed=true
	while (i<=ntbNumberOfBuffs and notPotUsed) do
		if (ntBuff[playerName..class]["enHPOTa"..i] and ntBuff[playerName..class][prefix.."HPOTa"..i]) then
			if (hpr<ntBuff[playerName..class]["HPOTaHP"..i] and ntBuff[playerName..class]["HPOTaSlot"..i]~=nil) then
				if ntBuff[playerName..class]["overwriteHPOTa"..i] or not ntBuff_hasBuffbyName(ntBuff[playerName..class]["HPOTaSlot"..i]) then
					notPotUsed= not ntBuff_usePot(ntBuff[playerName..class]["HPOTaSlot"..i]);
				end
			end
		end
		i=i+1;
	end
	
	-- MP
	if UnitMaxMana("player")>0 then 
		mpr = UnitMana("player")/UnitMaxMana("player")*100;
	else
		mpr =111
	end
	if not (ntbEmergency and ntBuff[playerName..class]["HPfirstMode"]) then
		local i=1;
		while (i<=ntbNumberOfBuffs and notPotUsed) do
			if (ntBuff[playerName..class]["enMPOTa"..i] and ntBuff[playerName..class][prefix.."MPOTa"..i]) then
				if (mpr<ntBuff[playerName..class]["MPOTaHP"..i] and ntBuff[playerName..class]["MPOTaSlot"..i]~=nil) then
					if ntBuff[playerName..class]["overwriteMPOTa"..i] or not ntBuff_hasBuffbyName(ntBuff[playerName..class]["MPOTaSlot"..i]) then
						notPotUsed= not ntBuff_usePot(ntBuff[playerName..class]["MPOTaSlot"..i]);
					end
				end
			end
			i=i+1;
		end
	end
	
	-- SP
	if UnitMaxSkill("player")>0 then 
		mpr = UnitSkill("player")/UnitMaxSkill("player")*100;
	else
		mpr =111
	end
	
	if not (ntbEmergency and ntBuff[playerName..class]["HPfirstMode"]) then
		local i=1;
		while (i<=ntbNumberOfBuffs and notPotUsed) do
			if (ntBuff[playerName..class]["enSPOTa"..i] and ntBuff[playerName..class][prefix.."SPOTa"..i]) then
				if (mpr<ntBuff[playerName..class]["SPOTaHP"..i] and ntBuff[playerName..class]["SPOTaSlot"..i]~=nil) then
					if ntBuff[playerName..class]["overwriteSPOTa"..i] or not ntBuff_hasBuffbyName(ntBuff[playerName..class]["SPOTaSlot"..i]) then
						notPotUsed= not ntBuff_usePot(ntBuff[playerName..class]["SPOTaSlot"..i]);
					end
				end
			end
			i=i+1;
		end
	end
	
	return (not notPotUsed)
end


-- ======================================================
-- ============= HEALING FUNCTIONS ======================
-- ======================================================
function ntBuff_SwapEquipment()
	hpr = UnitHealth("player")/UnitMaxHealth("player")*100

	-- Swap Equipment 
	if ntBuff[playerName..class]["Equipment1"] then
		if hpr<ntBuff[playerName..class]["Equipment1Rate"] then
			if GetEuipmentNumber() ~= ntBuff[playerName..class]["Equipment1Slot"] then
				SwapEquipmentItem()
			end
			if ntBuff[playerName..class]["Pause"] then
				ntbPause = true
			end
			
		end
	end
	
	if ntBuff[playerName..class]["Equipment2"] then
		if hpr>ntBuff[playerName..class]["Equipment2Rate"] then
			if GetEuipmentNumber() ~= ntBuff[playerName..class]["Equipment2Slot"] then
				SwapEquipmentItem()
			end
			if ntBuff[playerName..class]["Restart"] then
				ntbPause = false
			end
		end
	end

end


function ntBuff_Heal()
	hpr = UnitHealth("player")/UnitMaxHealth("player")*100
	local healCasted=false
	
	-- Critical spell
	if(hpr < ntBuff[playerName..class]["uCastRate"]) then
		if(ntBuff[playerName..class]["castUltimate"] == true) then
			healCasted=ntBuff_doBuff(ntBuff[playerName..class]["uSlot"]);
		end
	end

	-- Ctitical pot
	if(hpr < ntBuff[playerName..class]["uPotRate"] and not healCasted)then
		if(ntBuff[playerName..class]["uPot"] == true) then
			if(GetActionUsable(ntBuff[playerName..class]["uPotSlot"]) == true) then
				healCasted=ntBuff_doBuff(ntBuff[playerName..class]["uPotSlot"]);
			end
		end
	end

	-- Heal 1
	if hpr < ntBuff[playerName..class]["hRate1"] and not healCasted then
		if (ntBuff[playerName..class]["castHeal"] == true and casting == false) then
			if ((GetTime()-lastHeal) > 1.5) then
				healCasted=ntBuff_doBuff(ntBuff[playerName..class]["healSlot1"]);
				lastHeal = GetTime();
			end				
		end
	end

	-- Heal 2
	if hpr < ntBuff[playerName..class]["hRate2"] and not healCasted then
		if (ntBuff[playerName..class]["castHeal2"] == true and casting == false) then
			if ((GetTime()-lastHeal2) > 1.5) then
				healCasted=ntBuff_doBuff(ntBuff[playerName..class]["healSlot2"]);
				lastHeal2 = GetTime();
			end				
		end
	end
	return healCasted
end


function ntBuff_checkStats()
	local casted=false
	if not ntbPause then
		casted = ntBuff_Heal() 
		if not casted then
			casted = ntBuff_pot();
		end
		if not casted then
			casted = ntBuff_AdvPot();
		end
	end
	return casted
end

-- =================================================
-- ============= Begin Menu Functions ==============
-- =================================================

SLASH_ntBuff1 = "/ntBuff";
SLASH_ntBuff2 = "/ntb";

function ntBuff_GetWords(str)
	local ret = {};
	local pos=0;
	local word;
	_,pos,word=string.find(str, "^ *([^%s^\"]+) *", pos+1);
	if(not word) then
		return ret;
	end
	table.insert(ret, word);
	table.insert(ret, string.sub(str,pos+1));
	return ret;

end

		
SlashCmdList["ntBuff"] = function (editBox, msg)
	local params = ntBuff_GetWords(msg);
	local done =false;
	local text ="";
	
	if ( not params[1]) then 
		ntBuff_openConfig(); 
		params[1]="";
		done=true;
	end
	
	if (not params[2]) then params[2]=""; end
	params[1]=string.lower(params[1]);
	params[2]=string.lower(params[2]);
	
	if (params[1]=="help") then ntBuff_showHelp(); end
	
	for i=1, ntbNumberOfHealthPots do 
		if (params[1]=="hpot"..i) then
			if (params[2]=="on") then 
				ntBuff[playerName..class]["hPotEn"..i]=true;
				text = "HP pot "..i.."(slot#"..ntBuff[playerName..class]["hPotSlot"..i]..") enabled";
				DEFAULT_CHAT_FRAME:AddMessage(text);
			elseif (params[2]=="off") then 
				ntBuff[playerName..class]["hPotEn"..i]=false;
				text = "HP pot "..i.."(slot#"..ntBuff[playerName..class]["hPotSlot"..i]..") disabled";
				DEFAULT_CHAT_FRAME:AddMessage(text);				
			else
				ntBuff_openConfig();
			end
		done=true;
		end
	end
	
	for i=1, ntbNumberOfManaPots do 
		if (params[1]=="mpot"..i) then
			if (params[2]=="on") then 
				ntBuff[playerName..class]["mPotEn"..i]=true;
				text = "MP pot "..i.."(slot#"..ntBuff[playerName..class]["mPotSlot"..i]..") enabled";
				DEFAULT_CHAT_FRAME:AddMessage(text); 
			elseif (params[2]=="off") then 
				ntBuff[playerName..class]["mPotEn"..i]=false;
				text = "MP pot "..i.."(slot#"..ntBuff[playerName..class]["mPotSlot"..i]..") enabled";
				DEFAULT_CHAT_FRAME:AddMessage(text); 
			else
				ntBuff_openConfig();
			end
		done=true;
		end
	end
	
	for i=1, ntbNumberOfBuffs do
		if (params[1]=="buff"..i) then
			if (params[2]=="on") then 
				ntBuff[playerName..class]["entBuff"..i]=true; 
				text = "Buff "..i.."(slot#"..ntBuff[playerName..class]["bslot"..i]..") enabled";
				DEFAULT_CHAT_FRAME:AddMessage(text);
			elseif (params[2]=="off") then 
				ntBuff[playerName..class]["entBuff"..i]=false; 
				text = "Buff "..i.."(slot#"..ntBuff[playerName..class]["bslot"..i]..") disabled";
				DEFAULT_CHAT_FRAME:AddMessage(text);
			else
				ntBuff_openConfig();
			end
		done=true;
		end
	end
	
	if (not done) then
		if (params[1]=="on") then 
			ntBuff[playerName..class]["enabled"]=true;
			DEFAULT_CHAT_FRAME:AddMessage("ntBuff: enabled");
		elseif (params[1]=="off") then 
			ntBuff[playerName..class]["enabled"]=false;
			DEFAULT_CHAT_FRAME:AddMessage("ntBuff: disabled");
		elseif (params[1]=="toggle") then ntBuff_toggle();
		elseif (params[1]=="check") then
			if (params[2]=="stats") then ntBuff_checkStats(); end
			if (params[2]=="buff") then ntBuff_checkBuff(); end 
		elseif (params[1]=="restart") then ntbInitializeLocalVars();
		elseif (params[1]=="example") then ntBuff_showExample(); 
		elseif (params[1]=="config") then ntBuff_openConfig(); 
		else
			ntBuff_showHelp();
		end
	end
end

function ntBuff_toggle()
	if ntbPause then 
		ntbPause= false
		return
	end

	ntBuff[playerName..class]["enabled"]= not ntBuff[playerName..class]["enabled"];
	if ntBuff[playerName..class]["enabled"] then
		DEFAULT_CHAT_FRAME:AddMessage("ntBuff: enabled");
	else
		DEFAULT_CHAT_FRAME:AddMessage("ntBuff: disabled");
	end
end

function ntBuff_showHelp()
	DEFAULT_CHAT_FRAME:AddMessage("help/config: show this help/config window");
	DEFAULT_CHAT_FRAME:AddMessage("h/mPot[1..5] on/off: enable/disable HP/MP pot 1..5");
	DEFAULT_CHAT_FRAME:AddMessage("Buff[1..12] on/off: enable/disable buff 1..12");
	DEFAULT_CHAT_FRAME:AddMessage("on/off/toggle: enable/disable/toggle ntBuff");
	DEFAULT_CHAT_FRAME:AddMessage("check Stats/Buff: manual check for stats/buff");
	DEFAULT_CHAT_FRAME:AddMessage("restart: restart ntBuff ");
	DEFAULT_CHAT_FRAME:AddMessage("example: show examples for commands ");
end
function ntBuff_showExample()
	DEFAULT_CHAT_FRAME:AddMessage("ntBuff command examples");
	DEFAULT_CHAT_FRAME:AddMessage("- open config window = /ntb config");
	DEFAULT_CHAT_FRAME:AddMessage("- turn on ntBuff = /ntb on");
	DEFAULT_CHAT_FRAME:AddMessage("- disable HP pot 1 = /ntb hPot1 off");
	DEFAULT_CHAT_FRAME:AddMessage("- start buff check manually = /ntb check Buff");	
end

function ntBuff_setChecks() 
	local checkButton
-- ========================================================================|
-- ======================= BUFF WINDOW ====================================|
-- ========================================================================|
	for i=1, ntbNumberOfBuffs do
		local checkButton1 = getglobal("ntBuff_buff"..i.."CheckButton1");
		if(ntBuff[playerName..class]["entBuff"..i] == true) then
			checkButton1:SetChecked(1);
		else
			checkButton1:SetChecked(false);
		end
		local checkButton2 = getglobal("ntBuff_buff"..i.."CheckButton2");
		if(ntBuff[playerName..class]["cBuff"..i] == true) then
			checkButton2:SetChecked(1);
		else
			checkButton2:SetChecked(false);
		end
		local checkButton3 = getglobal("ntBuff_buff"..i.."CheckButton3");
		if(ntBuff[playerName..class]["aBuff"..i] == true) then
			checkButton3:SetChecked(1);
		else
			checkButton3:SetChecked(false);
		end
		local checkButton4 = getglobal("ntBuff_buff"..i.."CheckButton4");
		if(ntBuff[playerName..class]["rBuff"..i] == true) then
			checkButton4:SetChecked(1);
		else
			checkButton4:SetChecked(false);
		end
	end
	
	
-- ========================================================================|
-- ======================= POT WINDOW  ====================================|
-- ========================================================================|
	for i=1, ntbNumberOfHealthPots  do
		local checkButton1 = getglobal("ntBuff_hpot"..i.."CheckButton1");
		if(ntBuff[playerName..class]["hPotEn"..i] == true) then
			checkButton1:SetChecked(1);
		else
			checkButton1:SetChecked(false);
		end
	end
	
	for i=1, ntbNumberOfManaPots  do
		local checkButton1 = getglobal("ntBuff_mpot"..i.."CheckButton1");
		if(ntBuff[playerName..class]["mPotEn"..i] == true) then
			checkButton1:SetChecked(1);
		else
			checkButton1:SetChecked(false);
		end
	end
	
	if ntBuff[playerName..class]["HPfirstMode"] then
		ntBuff_HPfirstModeCheckButton1:SetChecked(1);
	else
		ntBuff_HPfirstModeCheckButton1:SetChecked(false);
	end
	
-- ========================================================================|
-- ======================= Adv HP POT WINDOW  =============================|
-- ========================================================================|
	for i=1, ntbNumberOfBuffs do
		checkButton = getglobal("ntBuff_hpota"..i.."CheckButton1");
		if(ntBuff[playerName..class]["enHPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_hpota"..i.."CheckButton2");
		if(ntBuff[playerName..class]["cHPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_hpota"..i.."CheckButton3");
		if(ntBuff[playerName..class]["aHPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
		
		checkButton = getglobal("ntBuff_hpota"..i.."CheckButton4");
		if(ntBuff[playerName..class]["rHPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_hpota"..i.."CheckButton5");
		if(ntBuff[playerName..class]["overwriteHPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
	end
	
-- ========================================================================|
-- ======================= Adv MP POT WINDOW  =============================|
-- ========================================================================|
	for i=1, ntbNumberOfBuffs do
		checkButton = getglobal("ntBuff_mpota"..i.."CheckButton1");
		if(ntBuff[playerName..class]["enMPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_mpota"..i.."CheckButton2");
		if(ntBuff[playerName..class]["cMPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_mpota"..i.."CheckButton3");
		if(ntBuff[playerName..class]["aMPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
		
		checkButton = getglobal("ntBuff_mpota"..i.."CheckButton4");
		if(ntBuff[playerName..class]["rMPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_mpota"..i.."CheckButton5");
		if(ntBuff[playerName..class]["overwriteMPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
	end
-- ========================================================================|
-- ======================= Adv HP POT WINDOW  =============================|
-- ========================================================================|
	for i=1, ntbNumberOfBuffs do
		checkButton = getglobal("ntBuff_spota"..i.."CheckButton1");
		if(ntBuff[playerName..class]["enSPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_spota"..i.."CheckButton2");
		if(ntBuff[playerName..class]["cSPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_spota"..i.."CheckButton3");
		if(ntBuff[playerName..class]["aSPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
		
		checkButton = getglobal("ntBuff_spota"..i.."CheckButton4");
		if(ntBuff[playerName..class]["rSPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end

		checkButton = getglobal("ntBuff_spota"..i.."CheckButton5");
		if(ntBuff[playerName..class]["overwriteSPOTa"..i] == true) then
			checkButton:SetChecked(1);
		else
			checkButton:SetChecked(false);
		end
	end	
	
	
-- ========================================================================|
-- ======================= HEAL WINDOW  ===================================|
-- ========================================================================|

	
	if(ntBuff[playerName..class]["castHeal"] == true) then
		ntBuff_healCheckButton1:SetChecked(1);
	else
		ntBuff_healCheckButton1:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["castHeal2"] == true) then
		ntBuff_heal2CheckButton1:SetChecked(1);
	else
		ntBuff_heal2CheckButton1:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["castUltimate"] == true) then
		ntBuff_critsCheckButton1:SetChecked(1);
	else
		ntBuff_critsCheckButton1:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["uPot"] == true) then
		ntBuff_critpCheckButton1:SetChecked(1);
	else
		ntBuff_critpCheckButton1:SetChecked(false);
	end
	
	if( not ntBuff[playerName..class]["Equipment1"] ) then
		ntBuff_critEquip1CheckButton1:SetChecked(false);
	else
		ntBuff_critEquip1CheckButton1:SetChecked(1);
	end
	
	if( not ntBuff[playerName..class]["Equipment2"] ) then
		ntBuff_critEquip2CheckButton1:SetChecked(false);
	else
		ntBuff_critEquip2CheckButton1:SetChecked(1);
	end
	
	ntBuff_critEquip1CheckButton2:SetChecked(ntBuff[playerName..class]["Pause"])
	ntBuff_critEquip2CheckButton2:SetChecked(ntBuff[playerName..class]["Restart"])
	
	
-- ========================================================================|
-- ======================= General Settings WINDOW  =======================|
-- ========================================================================|

	
	if(ntBuff[playerName..class]["enabled"] == true) then
		ntBuff_EnableCheckButton:SetChecked(1);
	else
		ntBuff_EnableCheckButton:SetChecked(false);
	end

	if(ntBuff[playerName..class]["hideFocus"] == true) then
		ntBuff_FocusFrameCheckButton:SetChecked(1);
	else
		ntBuff_FocusFrameCheckButton:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["PvPmode"] == true) then
		ntBuff_PvPModeCheckButton:SetChecked(1);
	else
		ntBuff_PvPModeCheckButton:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["PTmode"] == true) then
		ntBuff_PTModeCheckButton:SetChecked(1);
	else
		ntBuff_PTModeCheckButton:SetChecked(false);
	end
	
	if(ntBuff[playerName..class]["hideButton"] == true) then
		ntBuff_ButtonCheckButton:SetChecked(1);
	else
		ntBuff_ButtonCheckButton:SetChecked(false);
	end
	
-- GC
	if(ntBuff["GCdebug"] == true) then
		ntBuff_GCCheckButton:SetChecked(1);
	else
		ntBuff_GCCheckButton:SetChecked(false);
	end

-- Hook
	ntBuff_HookCheckButton1:SetChecked(ntBuff[playerName..class]["HookMouse"])
	ntBuff_HookCheckButton2:SetChecked(ntBuff[playerName..class]["HookMovement"])
	ntBuff_HookCheckButton3A:SetChecked(ntBuff[playerName..class]["HookSC"])
	ntBuff_HookCheckButton3B:SetChecked(ntBuff[playerName..class]["HookAllSC"])
	
	
	
end

function ntBuff_setText()


-- ======================= BUFF WINDOW ====================================|
	
	
	for i=1, ntbNumberOfBuffs do
		getglobal("ntBuff_buff"..i.."SpellLabeL1"):SetText(i);
		local editBox1 = getglobal("ntBuff_buff"..i.."Edit1");
		editBox1:SetText(ntBuff[playerName..class]["bslot"..i]);
	end
	ntBuff_buffConfigEdit1:SetText(ntBuff[playerName..class]["alertDuration"]);
-- ======================= HEAL WINDOW ====================================|
	ntBuff_healEdit1:SetText(ntBuff[playerName..class]["healSlot1"]);
	ntBuff_healEdit2:SetText(ntBuff[playerName..class]["hRate1"]);
	ntBuff_heal2Edit1:SetText(ntBuff[playerName..class]["healSlot2"]);
	ntBuff_heal2Edit2:SetText(ntBuff[playerName..class]["hRate2"]);
	
	ntBuff_critsEdit1:SetText(ntBuff[playerName..class]["uSlot"]);
	ntBuff_critsEdit2:SetText(ntBuff[playerName..class]["uCastRate"]);
	
	ntBuff_critpEdit1:SetText(ntBuff[playerName..class]["uPotSlot"]);
	ntBuff_critpEdit2:SetText(ntBuff[playerName..class]["uPotRate"]);
	
	ntBuff_critEquip1Edit1:SetText(ntBuff[playerName..class]["Equipment1Slot"])
	ntBuff_critEquip1Edit2:SetText(ntBuff[playerName..class]["Equipment1Rate"])

	ntBuff_critEquip2Edit1:SetText(ntBuff[playerName..class]["Equipment2Slot"])
	ntBuff_critEquip2Edit2:SetText(ntBuff[playerName..class]["Equipment2Rate"])

	-- ntBuff_critEquip1Edit3:SetText(ntBuff[playerName..class]["Equipment1Macro"])
	-- ntBuff_critEquip2Edit3:SetText(ntBuff[playerName..class]["Equipment2Macro"])
	
	
-- ======================= POT WINDOW ====================================|
	for i=1, ntbNumberOfHealthPots  do
		getglobal("ntBuff_hpot"..i.."SpellLabeL1"):SetText(i..":");
		getglobal("ntBuff_hpot"..i.."Edit1"):SetText(ntBuff[playerName..class]["hPotSlot"..i]);
		getglobal("ntBuff_hpot"..i.."Edit2"):SetText(ntBuff[playerName..class]["hPotRate"..i]);
	end	
	
	for i=1, ntbNumberOfManaPots  do
		getglobal("ntBuff_mpot"..i.."SpellLabeL1"):SetText(i..":");
		getglobal("ntBuff_mpot"..i.."Edit1"):SetText(ntBuff[playerName..class]["mPotSlot"..i]);
		getglobal("ntBuff_mpot"..i.."Edit2"):SetText(ntBuff[playerName..class]["mPotRate"..i]);
		getglobal("ntBuff_mpot"..i.."SpellLabeL4"):SetText(NTB_PAR_MANA);
	end
	ntBuff_HPfirstModeEdit1:SetText(ntBuff[playerName..class]["HPemergency"]);
	ntBuff_HPfirstModeEdit2:SetText(ntBuff[playerName..class]["HPsafe"]);
		
-- ======================= General Settings WINDOW ======================|
	ntBuff_ChkInt_COMBATSlider:SetValue(ntBuff[playerName..class]["chkIntC"]);
	ntBuff_ChkInt_ALERTSlider:SetValue(ntBuff[playerName..class]["chkIntA"]);
	ntBuff_ChkInt_RESTSlider:SetValue(ntBuff[playerName..class]["chkIntR"]);	
	
-- Adv  pot
	for i=1, ntbNumberOfBuffs do
		local editBox = getglobal("ntBuff_hpota"..i.."Edit1");
		editBox:SetText(ntBuff[playerName..class]["HPOTaSlot"..i]);
		editBox = getglobal("ntBuff_hpota"..i.."Edit2");
		editBox:SetText(ntBuff[playerName..class]["HPOTaHP"..i]);
		
		editBox = getglobal("ntBuff_mpota"..i.."Edit1");
		editBox:SetText(ntBuff[playerName..class]["MPOTaSlot"..i]);
		editBox = getglobal("ntBuff_mpota"..i.."Edit2");
		editBox:SetText(ntBuff[playerName..class]["MPOTaHP"..i]);
		
		editBox = getglobal("ntBuff_spota"..i.."Edit1");
		editBox:SetText(ntBuff[playerName..class]["SPOTaSlot"..i]);
		editBox = getglobal("ntBuff_spota"..i.."Edit2");
		editBox:SetText(ntBuff[playerName..class]["SPOTaHP"..i]);
		
	end
	
-- GC settings
	if (not ntBuff["GCpause"]) then ntBuff["GCpause"]=100 end
	ntBuff_incGC_pauseSlider:SetValue(ntBuff["GCpause"]);
	if (not ntBuff["GCstepmul"]) then ntBuff["GCstepmul"]=0 end
	ntBuff_incGC_stepmulSlider:SetValue(ntBuff["GCstepmul"]);
	if (not ntBuff["GCsize"]) then ntBuff["GCsize"]=50 end
	ntBuff_stepGC_SizeSlider:SetValue(ntBuff["GCsize"]);
	if (not ntBuff["GCloop"]) then ntBuff["GCloop"]=10 end
	ntBuff_stepGC_LoopSlider:SetValue(ntBuff["GCloop"]);
	if (not ntBuff["GCnonCombat"]) then ntBuff["GCnonCombat"]=80 end
	ntBuff_fullGC_nonCombatSlider:SetValue(ntBuff["GCnonCombat"]);
	if (not ntBuff["GCcombat"]) then ntBuff["GCcombat"]=80 end
	ntBuff_fullGC_CombatSlider:SetValue(ntBuff["GCcombat"]);	
	if (not ntBuff["GCchannelNum"]) then ntBuff["GCchannelNum"]="" end
	ntBuffGCEdit1:SetText(ntBuff["GCchannelNum"]);
	
-- Hook settings
	if (not ntBuff[playerName..class]["MouseSens"]) then ntBuff[playerName..class]["MouseSens"]=20 end
	ntBuff_Hook_sensitivitySlider:SetValue(ntBuff[playerName..class]["MouseSens"])
	if (ntBuff[playerName..class]["HookSCPos"]) then
		for i=1, 15 do 
			getglobal("ntBuffHookEdit"..i):SetText(ntBuff[playerName..class]["HookSCPos"][i])
		end
	end
	
end

function ntBuff_saveBuff() 
	for i=1, ntbNumberOfBuffs do
		
		local checkButton=getglobal("ntBuff_buff"..i.."CheckButton2")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["cBuff"..i] = true;
		else
			ntBuff[playerName..class]["cBuff"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_buff"..i.."CheckButton3")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["aBuff"..i] = true;
		else
			ntBuff[playerName..class]["aBuff"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_buff"..i.."CheckButton4")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["rBuff"..i] = true;
		else
			ntBuff[playerName..class]["rBuff"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_buff"..i.."CheckButton1")
		if(checkButton:IsChecked()) then
			ntBuff[playerName..class]["entBuff"..i] = true;
		else
			ntBuff[playerName..class]["entBuff"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_buff"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["bslot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["bslot"..i] = 0;
			ntBuff[playerName..class]["entBuff"..i] = false;
		end

	end

	local tmp = ntBuff_buffConfigEdit1:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["alertDuration"] = tonumber(tmp);
	else
		ntBuff[playerName..class]["alertDuration"] = 15;
	end

end

function ntBuff_savePots()
	-- --------------- HPOT ------------------
	for i=1, ntbNumberOfHealthPots  do
		local checkButton=getglobal("ntBuff_hpot"..i.."CheckButton1");
		if(checkButton:IsChecked()) then
			ntBuff[playerName..class]["hPotEn"..i] = true;
		else
			ntBuff[playerName..class]["hPotEn"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_hpot"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["hPotSlot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["hPotSlot"..i] = 0;
			ntBuff[playerName..class]["hPotEn"..i] = false;
		end
	
		local tmp2 = getglobal("ntBuff_hpot"..i.."Edit2"):GetText()
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["hPotRate"..i] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["hPotRate"..i] = 0;
			ntBuff[playerName..class]["hPotEn"..i] = false;
		end
	end
	
	-- --------------- MPOT ------------------
	for i=1, ntbNumberOfManaPots  do
		local checkButton=getglobal("ntBuff_mpot"..i.."CheckButton1");
		if(checkButton:IsChecked()) then
			ntBuff[playerName..class]["mPotEn"..i] = true;
		else
			ntBuff[playerName..class]["mPotEn"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_mpot"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["mPotSlot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["mPotSlot"..i] = 0;
			ntBuff[playerName..class]["mPotEn"..i] = false;
		end
	
		local tmp2 = getglobal("ntBuff_mpot"..i.."Edit2"):GetText()
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["mPotRate"..i] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["mPotRate"..i] = 0;
			ntBuff[playerName..class]["mPotEn"..i] = false;
		end
	end
	
	-- other --
	
	if ntBuff_HPfirstModeCheckButton1:IsChecked() then
		ntBuff[playerName..class]["HPfirstMode"] =true;
	else
		ntBuff[playerName..class]["HPfirstMode"] =false;
	end
	
	local tmp = ntBuff_HPfirstModeEdit1:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["HPemergency"] = tonumber(tmp);
	else
		ntBuff[playerName..class]["HPemergency"] = 25;
	end
	
	tmp = ntBuff_HPfirstModeEdit2:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["HPsafe"] = tonumber(tmp);
	else
		ntBuff[playerName..class]["HPsafe"] = 25;
	end
end 

function ntBuff_saveHeal() 
	local tmp=""
	local tmp2=""

	-- --------------- HEAL 1 ------------------
	if(ntBuff_healCheckButton1:IsChecked()) then
		ntBuff[playerName..class]["castHeal"] = true;
		
		tmp = ntBuff_healEdit1:GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["healSlot1"] = tonumber(tmp);
		else
			ntBuff[playerName..class]["castHeal"] = false;
		end
		
		tmp2 = ntBuff_healEdit2:GetText();
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["hRate1"] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["castHeal"] = false;
		end
			
	else
		ntBuff[playerName..class]["castHeal"] = false;
	end
	
	-- --------------- HEAL 2 ------------------
	if(ntBuff_heal2CheckButton1:IsChecked()) then
		ntBuff[playerName..class]["castHeal2"] = true;
		
		tmp = ntBuff_heal2Edit1:GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["healSlot2"] = tonumber(tmp);
		else
			ntBuff[playerName..class]["castHeal2"] = false;
		end
		
		tmp2 = ntBuff_heal2Edit2:GetText();
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["hRate2"] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["castHeal2"] = false;
		end
			
	else
		ntBuff[playerName..class]["castHeal2"] = false;
	end
	
	-- --------------- Critical Spell ------------------
	if(ntBuff_critsCheckButton1:IsChecked()) then
		ntBuff[playerName..class]["castUltimate"] = true;
		
		tmp = ntBuff_critsEdit1:GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["uSlot"] = tonumber(tmp);
		else
			ntBuff[playerName..class]["castUltimate"] = false;
		end
		
		tmp2 = ntBuff_critsEdit2:GetText();
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["uCastRate"] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["castUltimate"] = false;
		end
			
	else
		ntBuff[playerName..class]["castUltimate"] = false;
	end
	
	-- --------------- Critical Pot ------------------
	if(ntBuff_critpCheckButton1:IsChecked()) then
		ntBuff[playerName..class]["uPot"] = true;
		
		tmp = ntBuff_critpEdit1:GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["uPotSlot"] = tonumber(tmp);
		else
			ntBuff[playerName..class]["uPot"] = false;
		end
		
		tmp2 = ntBuff_critpEdit2:GetText();
		if(tmp2 ~= "") then
			assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["uPotRate"] = tonumber(tmp2);
		else
			ntBuff[playerName..class]["uPot"] = false;
		end
			
	else
		ntBuff[playerName..class]["uPot"] = false;
	end
	
	-- Equipment
	ntBuff[playerName..class]["Equipment1"] = ntBuff_critEquip1CheckButton1:IsChecked()	
	tmp = ntBuff_critEquip1Edit1:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["Equipment1Slot"] = tonumber(tmp);
	else
		ntBuff[playerName..class]["Equipment1"] = false;
	end
	
	tmp2 = ntBuff_critEquip1Edit2:GetText();
	if(tmp2 ~= "") then
		assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["Equipment1Rate"] = tonumber(tmp2);
	else
		ntBuff[playerName..class]["Equipment1"] = false;
	end
	
	-- tmp = ntBuff_critEquip1Edit3:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["Equipment1Macro"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["Equipment1"] = false;
	-- end
	
	ntBuff[playerName..class]["Pause"]=ntBuff_critEquip1CheckButton2:IsChecked()
		
	ntBuff[playerName..class]["Equipment2"] = ntBuff_critEquip1CheckButton2:IsChecked()	
	tmp = ntBuff_critEquip2Edit1:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["Equipment2Slot"] = tonumber(tmp);
	else
		ntBuff[playerName..class]["Equipment2"] = false;
	end
	tmp2 = ntBuff_critEquip2Edit2:GetText();
	if(tmp2 ~= "") then
		assert(tonumber(tmp2), ntbuff_conf.invalid..tmp2..ntbuff_conf.isnotnumber);
		ntBuff[playerName..class]["Equipment2Rate"] = tonumber(tmp2);
	else
		ntBuff[playerName..class]["Equipment2"] = false;
	end
	-- tmp = ntBuff_critEquip2Edit3:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["Equipment2Macro"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["Equipment2"] = false;
	-- end
	
	ntBuff[playerName..class]["Restart"]=ntBuff_critEquip2CheckButton2:IsChecked()
	
	
	
	-- Enabled check button
	
	if(ntBuff_EnableCheckButton:IsChecked()) then
		ntBuff[playerName..class]["enabled"] = true;
	else
		ntBuff[playerName..class]["enabled"] = false;
	end

	if(ntBuff_FocusFrameCheckButton:IsChecked()) then
		ntBuff[playerName..class]["hideFocus"] = true;
		hideFocus=true;
	else
		ntBuff[playerName..class]["hideFocus"] = false;
		hideFocus=false;
	end

	if(ntBuff_PvPModeCheckButton:IsChecked()) then
		ntBuff[playerName..class]["PvPmode"] = true;
	else
		ntBuff[playerName..class]["PvPmode"] = false;
	end

	if(ntBuff_PTModeCheckButton:IsChecked()) then
		ntBuff[playerName..class]["PTmode"] = true;
	else
		ntBuff[playerName..class]["PTmode"] = false;
	end
	
	if(ntBuff_ButtonCheckButton:IsChecked()) then
		ntBuff[playerName..class]["hideButton"] = true;
		ntBuff_Status:Hide();
	else
		ntBuff[playerName..class]["hideButton"] = false;
		ntBuff_Status:Show();
	end

	-- local tmp = ntBuff_chkInt:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["chkInt"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["chkInt"] = updateInt;
	-- end

	-- local tmp = ntBuff_LoadingTime:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["LoadingTime"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["LoadingTime"] = loadTime;
	-- end

	-- local tmp = ntBuff_CDafterLoading:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["CDafterLoading"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["CDafterLoading"] = waitAfterLoading;
	-- end
	
	-- local tmp = ntBuff_CDafterResurrect:GetText();
	-- if(tmp ~= "") then
		-- assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		-- ntBuff[playerName..class]["CDafterResurrect"] = tonumber(tmp);
	-- else
		-- ntBuff[playerName..class]["CDafterResurrect"] = waitAfterResurrect;
	-- end
	
	
	ntBuff[playerName..class]["chkIntC"]=ntBuff_ChkInt_COMBATSlider:GetValue();
	ntBuff[playerName..class]["chkIntA"]=ntBuff_ChkInt_ALERTSlider:GetValue();
	ntBuff[playerName..class]["chkIntR"]=ntBuff_ChkInt_RESTSlider:GetValue();	

end

function ntBuff_saveGCsettings()
	ntBuff["GCpause"]=ntBuff_incGC_pauseSlider:GetValue()
	ntBuff["GCstepmul"]=ntBuff_incGC_stepmulSlider:GetValue();
	ntBuff["GCsize"]=ntBuff_stepGC_SizeSlider:GetValue();
	ntBuff["GCloop"]=ntBuff_stepGC_LoopSlider:GetValue();
	ntBuff["GCnonCombat"]=ntBuff_fullGC_nonCombatSlider:GetValue();
	ntBuff["GCcombat"]=ntBuff_fullGC_CombatSlider:GetValue();
	if(ntBuff_GCCheckButton:IsChecked()) then
		ntBuff["GCdebug"] = true;
	else
		ntBuff["GCdebug"] = false;
	end
	collectgarbage("setpause", ntBuff["GCpause"]+100);
	collectgarbage("setstepmul", ntBuff["GCstepmul"]+200);
	
	local tmp = ntBuffGCEdit1:GetText();
	if(tmp ~= "") then
		assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
		ntBuff.GCchannelNum = tonumber(tmp);
	else
		ntBuff.GCchannelNum=nil
	end
end

function ntBuff_saveAdvPots()
	for i=1, ntbNumberOfBuffs do	
		-- HP
		local checkButton=getglobal("ntBuff_hpota"..i.."CheckButton2")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["cHPOTa"..i] = true;
		else
			ntBuff[playerName..class]["cHPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_hpota"..i.."CheckButton3")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["aHPOTa"..i] = true;
		else
			ntBuff[playerName..class]["aHPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_hpota"..i.."CheckButton4")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["rHPOTa"..i] = true;
		else
			ntBuff[playerName..class]["rHPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_hpota"..i.."CheckButton1")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["enHPOTa"..i] = true;
		else
			ntBuff[playerName..class]["enHPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_hpota"..i.."CheckButton5")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["overwriteHPOTa"..i] = true;
		else
			ntBuff[playerName..class]["overwriteHPOTa"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_hpota"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["HPOTaSlot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["HPOTaSlot"..i] = 0;
			ntBuff[playerName..class]["enHPOTa"..i] = false;
		end
		
		tmp = getglobal("ntBuff_hpota"..i.."Edit2"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["HPOTaHP"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["HPOTaHP"..i] = 0;
			ntBuff[playerName..class]["enHPOTa"..i] = false;
		end
		
		-- MP
		checkButton=getglobal("ntBuff_mpota"..i.."CheckButton2")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["cMPOTa"..i] = true;
		else
			ntBuff[playerName..class]["cMPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_mpota"..i.."CheckButton3")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["aMPOTa"..i] = true;
		else
			ntBuff[playerName..class]["aMPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_mpota"..i.."CheckButton4")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["rMPOTa"..i] = true;
		else
			ntBuff[playerName..class]["rMPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_mpota"..i.."CheckButton1")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["enMPOTa"..i] = true;
		else
			ntBuff[playerName..class]["enMPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_mpota"..i.."CheckButton5")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["overwriteMPOTa"..i] = true;
		else
			ntBuff[playerName..class]["overwriteMPOTa"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_mpota"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["MPOTaSlot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["MPOTaSlot"..i] = 0;
			ntBuff[playerName..class]["enMPOTa"..i] = false;
		end
		
		tmp = getglobal("ntBuff_mpota"..i.."Edit2"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["MPOTaHP"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["MPOTaHP"..i] = 0;
			ntBuff[playerName..class]["enMPOTa"..i] = false;
		end
		
		--
		checkButton=getglobal("ntBuff_spota"..i.."CheckButton2")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["cSPOTa"..i] = true;
		else
			ntBuff[playerName..class]["cSPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_spota"..i.."CheckButton3")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["aSPOTa"..i] = true;
		else
			ntBuff[playerName..class]["aSPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_spota"..i.."CheckButton4")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["rSPOTa"..i] = true;
		else
			ntBuff[playerName..class]["rSPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_spota"..i.."CheckButton1")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["enSPOTa"..i] = true;
		else
			ntBuff[playerName..class]["enSPOTa"..i] = false;
		end
		
		checkButton=getglobal("ntBuff_spota"..i.."CheckButton5")
		if checkButton:IsChecked() then
			ntBuff[playerName..class]["overwriteSPOTa"..i] = true;
		else
			ntBuff[playerName..class]["overwriteSPOTa"..i] = false;
		end
		
		local tmp = getglobal("ntBuff_spota"..i.."Edit1"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["SPOTaSlot"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["SPOTaSlot"..i] = 0;
			ntBuff[playerName..class]["enSPOTa"..i] = false;
		end
		
		tmp = getglobal("ntBuff_spota"..i.."Edit2"):GetText();
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["SPOTaHP"..i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["SPOTaHP"..i] = 0;
			ntBuff[playerName..class]["enSPOTa"..i] = false;
		end

	end
end
	
function ntBuff_saveHookSettings()
	local tmp=""
	
	ntBuff[playerName..class]["HookMouse"]=ntBuff_HookCheckButton1:IsChecked()
	ntBuff[playerName..class]["HookMovement"]=ntBuff_HookCheckButton2:IsChecked()
	ntBuff[playerName..class]["HookSC"]=ntBuff_HookCheckButton3A:IsChecked()
	ntBuff[playerName..class]["HookAllSC"]=ntBuff_HookCheckButton3B:IsChecked()
	ntBuff[playerName..class]["MouseSens"]=ntBuff_Hook_sensitivitySlider:GetValue()
	ntBuff_PositionTriggeringFrames(ntBuff[playerName..class]["MouseSens"])
	
	if (not ntBuff[playerName..class]["HookSCPos"]) then ntBuff[playerName..class]["HookSCPos"]={} end
	for i=1, 15 do 
		tmp = getglobal("ntBuffHookEdit"..i):GetText()
		if(tmp ~= "") then
			assert(tonumber(tmp), ntbuff_conf.invalid..tmp..ntbuff_conf.isnotnumber);
			ntBuff[playerName..class]["HookSCPos"][i] = tonumber(tmp);
		else
			ntBuff[playerName..class]["HookSCPos"][i]=""
		end
	end	
end
	
function ntBuff_Trigger()
	if ntb_TriggerIcon=="OFF" then
		ntb_Trigger:SetFile("Interface/AddOns/ntBuff/img/LEDON.png")
		ntb_TriggerIcon="ON"
		if ntBuff[playerName..class]["HookMouse"] then
			ntBuff_HideTriggeringFrames()
		end		
		ntb_TriggerTime=GetTime()
		ntBuff_tryBuff()
	end
end

function ntBuff_MouseTrigger()
	if ntBuff[playerName..class]["HookMouse"] then
		ntBuff_Trigger()
	end
end	

function ntBuff_MovementTrigger()
	if ntBuff[playerName..class]["HookMovement"] then
		ntBuff_Trigger()
	end
end


local oldJump=Jump
function Jump()
	ntBuff_MovementTrigger()
	return oldJump()
end

local oldMoveForwardStart=MoveForwardStart
function MoveForwardStart()
	ntBuff_MovementTrigger()
	return oldMoveForwardStart()
end

local oldMoveForwardStop=MoveForwardStop
function MoveForwardStop()
	ntBuff_MovementTrigger()
	return oldMoveForwardStop()
end

local oldMoveBackwardStart=MoveBackwardStart
function MoveBackwardStart()
	ntBuff_MovementTrigger()
	return oldMoveBackwardStart()
end

local oldMoveBackwardStop=MoveBackwardStop
function MoveBackwardStop()
	ntBuff_MovementTrigger()
	return oldMoveBackwardStop()
end

local oldTurnLeftStart=TurnLeftStart
function TurnLeftStart()
	ntBuff_MovementTrigger()
	return oldTurnLeftStart()
end

local oldTurnLeftStop=TurnLeftStop
function TurnLeftStop()
	ntBuff_MovementTrigger()
	return oldTurnLeftStop()
end

local oldTurnRightStart=TurnRightStart
function TurnRightStart()
	ntBuff_MovementTrigger()
	return oldTurnRightStart()
end

local oldTurnRightStop=TurnRightStop
function TurnRightStop()
	ntBuff_MovementTrigger()
	return oldTurnRightStop()
end

local oldStrafeLeftStart=StrafeLeftStart
function StrafeLeftStart()
	ntBuff_MovementTrigger()
	return oldStrafeLeftStart()
end

local oldStrafeLeftStop=StrafeLeftStop
function StrafeLeftStop()
	ntBuff_MovementTrigger()
	return oldStrafeLeftStop()
end

local oldStrafeRightStart=StrafeRightStart
function StrafeRightStart()
	ntBuff_MovementTrigger()
	return oldStrafeRightStart()
end

local oldStrafeRightStop=StrafeRightStop
function StrafeRightStop()
	ntBuff_MovementTrigger()
	return oldStrafeRightStop()
end

local oldToggleSheath = ToggleSheath
function ToggleSheath()
	ntBuff_MovementTrigger()
	return oldToggleSheath()
end

local oldTargetNearestEnemy = TargetNearestEnemy
function TargetNearestEnemy()
	ntBuff_Trigger()
	return oldTargetNearestEnemy()
end

local oldTargetNearestFriend = TargetNearestFriend
function TargetNearestFriend()
	ntBuff_Trigger()
	return oldTargetNearestFriend()
end

local oldUseAction = UseAction
function UseAction(pos)
	if ntBuff[playerName..class]["HookSC"] then
		if ntBuff[playerName..class]["HookAllSC"] then
			ntBuff_Trigger()
		elseif ntBuff[playerName..class]["HookSCPos"] then
			for i=1, 15 do
				if tostring(ntBuff[playerName..class]["HookSCPos"][i])==tostring(pos) then
					ntBuff_Trigger()
				end
			end
		end
	end
	return oldUseAction(pos)
end

function ntBuff_saveAll()
	ntBuff_saveHeal();
	ntBuff_savePots();
	ntBuff_saveBuff();
	ntBuff_saveAdvPots();
	ntBuff_saveGCsettings();
	ntBuff_saveHookSettings()
	if(ntBuff[playerName..class]["enabled"] == true) then
		DEFAULT_CHAT_FRAME:AddMessage("[|cffffffffntBuff|r] "..ntbuff_conf.saveconf.." |r", 0.5, 0.7, 0.1);
	else
		DEFAULT_CHAT_FRAME:AddMessage("[|cffffffffntBuff|r] "..ntbuff_conf.disabled.." |r", 1, 0, 0);
	end
end


function ntBuff_openConfig()

	ntBuff_setText();
	ntBuff_setChecks();
	ntBuff_config:Show();
	ntActionButton_ShowHotKeys()
	
end

function ntBuff_AddonManager_Config()
	ntBuff_openConfig();
end

function ntBuff_AddonManager()
	if (AddonManager) then
		local addon = {
			name = "ntBuff",
			version = ntbVersion,
			author = "Tetty(TBD) based on Noktrin, ZsZso, Roukard and Dinalisa's code",
			description = NTB_DESCRIPTION,
  	 		icon = "Interface\\AddOns\\ntBuff\\img\\ntBuff.png",
			category = "Leveling",
			configFrame = ntBuff_config, 
			slashCommands = SLASH_ntBuff2,
			miniButton = ntBuffMiniButton,
		};
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author, addon.onClickScript);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("[|cffffffffntBuff v"..ntbVersion.."|r] loaded. Use |cffffffff/ntb|r for info. |r", 0.5, 0.7, 0.1);
	end
end

function ntbFrame_OnLoad(this)
	ntBuff_Status:Show();
	ntBuff_Status:RegisterEvent("VARIABLES_LOADED");
end

function ntbFrame_OnEvent(this, event, arg1, arg2)
	if( event == "VARIABLES_LOADED" ) then
		ntbFrame_LoadSettings();
	end
end

function ntbFrame_LoadSettings()
	if (not ntBuff["x"]) then ntBuff["x"], ntBuff["y"]=ntBuff_Status:GetPos(); end
	
	local scale = GetUIScale();
	ntBuff_Status:ClearAllAnchors();
	ntBuff_Status:SetAnchor("TOPLEFT","TOPLEFT","UIParent",ntBuff["x"]/scale,ntBuff["y"]/scale);
end

function ntbFrame_OnMouseUp()
	ntBuff["x"], ntBuff["y"] = ntBuff_Status:GetPos();
	SaveVariables("ntBuff");
end

function ntActionButton_ShowHotKeys()
	local key, pos, frame, info, button, hotkey
	for key, pos in pairs({"Main", "Right", "Left", "Bottom"}) do
		frame=getglobal(pos.."ActionBarFrame")
		--info = ActionBarInfo[frame:GetID()];
		for i = 1, ACTIONBAR_NUM_BUTTONS do
			button = getglobal(frame:GetName().."Button"..i);
			--if ( i <= info.count ) then			
				hotkey = getglobal(button:GetName().."Hotkey");
				hotkey:SetText(i+frame:GetID()*20-20);
			--end
		end
	end
end

function ntActionButton_ReturnOriginal()
	local key, pos, frame
	for key, pos in pairs({"Main", "Right", "Left", "Bottom"}) do
		frame=getglobal(pos.."ActionBarFrame")
		ActionBarFrame_Update(frame)
	end
end