-------------------------------------------------------------------------------
--
-- PLANTCARE v2.14.10
--
-- 
-- Last Update: 2011-11-25T19:05:23Z
-- 
-------------------------------------------------------------------------------


--
-- Setup some Global variables
--
local Sol = LibStub("Sol")

PlantCare = {
	Addonname = "PlantCare",
	Version = "v2.14.10",
	currentSeedInHand= 0,
	currentWaterSteps = 10,
	currentFertilizerSteps = 10,
	currentWaterFeeds = 1,
	currentFertilizerFeeds = 1,
	WaitForPlantingSuccessLoop = 0,
	caringForPlants = false,
	displayedHelp = false,
	watchCounter = 60,
	waterGrabbed = 0,
	topdressGrabbed = 0,
	Counter = 0,
	resetTimer = 0,
	plantCounter = 0,
	counterTimer = 0,
	shopWaterDisableTimer = 0,
	shopFertilizerDisableTimer = 0,
	action = "",
}

PlantCare.collect = {}

PlantCare.DefaultSettings = {
    Enabled = true,
    GetProduct = true,
    LongCare = false,
    AutoCare = true,
    MaxLevelMaterial = 80,
	MaxLevelRarity = 0,
	InfoCount = 0,
	AlertWater = true,
	AlertPercent = 60,
	AlertPercentUnder = 20,
	WaterSound = false,
	CountPlants = false,
	AutoSeed = true,
	WaterBeforeHarvest = false,
	Compensate = false,
  }

PlantCare.Materials = {
--[[
    Name, 
	Level, 
	Rarity (0=white, 1=green, 2=blue, 3=purple, 4=orange, 5=brown), 
	percent of water/fertilizer,
	stackable up to,
	percent of feeding level
]]
	Water = {
		{TEXT('Sys203815_name'),  1, 0, 10, 999, 1},  -- "Irrigation Water"
		{TEXT('Sys203816_name'), 19, 0, 10, 999, 1},  -- "River Water"
		{TEXT('Sys203817_name'), 37, 0, 10, 999, 1},  -- "Spring Water"

		{TEXT('Sys203818_name'), 55, 0, 10, 999, 1},  -- "Dew"
		{TEXT('Sys203819_name'),  1, 1, 20, 999, 8},  -- "Pixie Spring Water"
		{TEXT('Sys203820_name'), 40, 2, 20, 999, 8},  -- "Heavenly Spring Water"

		{TEXT('Sys208602_name'), 73, 0, 10, 999, 1},  -- "Wasser der Quelle des Lebens"
		{TEXT('Sys208623_name'), 80, 2, 20, 999, 8},  -- "Wasser der Sternenlichtquelle"
	},

	Fertilizer = {
		{TEXT('Sys203823_name'),  1, 0, 10, 999, 1},  -- "Compost Heap"
		{TEXT('Sys203824_name'), 19, 0, 10, 999, 1},  -- "Organic Fertilizer"
		{TEXT('Sys203825_name'), 37, 0, 10, 999, 1},  -- "Soil With Low Amounts of Nutrients"

		{TEXT('Sys203826_name'), 55, 0, 10, 999, 1},  -- "Soil With Medium Amounts of Nutrients"
		{TEXT('Sys203829_name'),  1, 1, 20, 999, 8},  -- "Pixie Soil"
		{TEXT('Sys203828_name'), 40, 2, 20, 999, 8},  -- "Rejuvenation Soil"

		{TEXT('Sys203827_name'), 73, 0, 10, 999, 1},  -- "Erde mit hohem Nährstoffgehalt"
		{TEXT('Sys208622_name'), 80, 2, 20, 999, 8},  -- "Himmlischer Staub"
	},
	
	Levels = 	{ 1, 19, 37, 40, 55, 73, 80 },
}
  
PlantCare.Seeds = {
--[[
	DBID, 
	Level, 
	smaller feeding value,
	bigger feeding value
]]
	Ore = {
		{204191, 1,30,75}, -- Rotkristall-Saatgut
		{204192, 7,30,75}, -- Gelbkristall-Saatgut
		{204193,13,30,75}, -- Weißkristall-Saatgut
		{204194,19,30,75}, -- Grünkristall-Saatgut
		{204195,25,35,80}, -- Blaukristall-Saatgut
		{204196,31,35,80}, -- Lehmdrachen-Saatgut
		{204197,37,35,80}, -- Erddrachennest-Saatgut
		{204198,43,40,85}, -- Feuerdrachennest-Saatgut
		{204199,49,40,85}, -- Vulkanstein-Saatgut
		{204200,55,40,85}, -- Geostein-Saatgut
		{208595,61,40,85}, -- Wellensamen
		{208599,67,40,85}, -- Glockenspielsamen
		{208616,73,40,85}, -- Nadelsamen
		{208617,79,40,85}, -- Samen des grünen Scheins
	},
	Herb = {
		{203994, 1,30,75}, -- Rattenschwanz-Rattansamen
		{203995, 7,30,75}, -- Grassamen
		{203996,13,30,75}, -- Kammgras-Sichelsamen
		{203997,19,30,75}, -- Flugreetsamen
		{203998,25,35,80}, -- Pferdehufsamen
		{203999,31,35,80}, -- Schwanenwollsamen
		{204000,37,35,80}, -- Nachtschreitersamen
		{204001,43,40,85}, -- Fliegender Wintersamen
		{204002,49,40,85}, -- Pegasusfedersamen
		{204003,55,40,85}, -- Engelsflügelsamen
		{208594,61,40,85}, -- Sternenstaubsamen
		{208598,67,40,85}, -- Dünensamen
		{208600,73,40,85}, -- Moschussamen der Liebe
		{208618,79,40,85}, -- Sonnenverwöhnter Samen
	},
	Wood = {
		{204181, 1,30,75}, -- Weinreben-Saatgut
		{204182, 7,30,75}, -- Grasbaum-Saatgut
		{204183,13,30,75}, -- Zertrampeltes-Saatgut
		{204184,19,30,75}, -- Hartbaumwoll-Saatgut
		{204185,25,35,80}, -- Wasserkastanien-Saatgut
		{204186,31,35,80}, -- Zauberreben-Saatgut
		{204187,37,35,80}, -- Langeisenstab-Saatgut
		{204188,43,40,85}, -- Feenbaum-Saatgut
		{204189,49,40,85}, -- Spaltholz-Saatgut
		{204190,55,40,85}, -- Brücken-Saatgut
		{208596,61,40,85}, -- Orangefarbener Mondsamen
		{208597,67,40,85}, -- Laternensamen
		{208601,73,40,85}, -- Aurorasamen
		{208619,79,40,85}, -- Echosamen
	},
}

PlantCare.BlockMessages = {
    {TEXT('SYS_PLANT_SEED_SUCCEED'),       0},
    {TEXT('SYS_PLANT_WATER_SUCCEED'),      0},
    {TEXT('SYS_PLANT_TOPDRESS_SUCCEED'),   0},
    {TEXT('SYS_PLANT_GETPRODUCT_SUCCEED'), 0},
  }

function PlantCare_OnLoad(frame)
	PlantCare.Language = string.upper(string.sub(GetLanguage(),1,2))

	local  func, err = loadfile("Interface/Addons/PlantCare/Locales/"..PlantCare.Language..".lua")
	if (err) then
		PlantCare.ErrMsg   = "\n\n|cffff0000No Locales found for your language \""..PlantCare.Language.."\", switching to fallback \"EN\"|r"
		PlantCare.Language = "EN"
	end

	dofile("Interface/Addons/PlantCare/Locales/"..PlantCare.Language..".lua")

	PlantCare.name    = "PlantCare"
	PlantCare.frame   = PlantCare_Frame

	frame:RegisterEvent("VARIABLES_LOADED")
	frame:RegisterEvent("HOUSES_PLANT_OPEN")
	frame:RegisterEvent("HOUSES_PLANT_CLOSE")
	frame:RegisterEvent("HOUSESFRAME_HIDE")
	frame:RegisterEvent("HOUSES_PLANT_CHANGED")
	frame:RegisterEvent("STORE_OPEN")
	frame:RegisterEvent("STORE_CLOSE")
	frame:RegisterEvent("UPDATE_STORE_BUYBACK_ITEMS")
	frame:RegisterEvent("UPDATE_STORE_SELL_ITEMS")

	-- Change Anchors and Size of PlantFrame
	PlantFrame:SetSize(280,415)
	PlantSeedInfoFrame :ClearAllAnchors(); PlantSeedInfoFrame :SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -283)
	PlantWaterInfoFrame:ClearAllAnchors(); PlantWaterInfoFrame:SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -143)
	PlantStateBer01    :ClearAllAnchors(); PlantStateBer01    :SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -255)

	GreenThumbFrame_PotInfoFrame          :Show()
	GreenThumbFrame_PotInfoFrameButton    :Disable()

	GreenThumbFrame_PotInfoFramePottitle :SetText(PlantCare.Strings.Potname..":")
	GreenThumbFrame_PotInfoFrameTypetitle:SetText(PlantCare.Strings.Pottype..":")

	PlantCare_Frame_PropertiesOpenButton:SetText(PlantCare.Strings.GUI_properties)
	PlantCare_Frame_CareButton:SetText(PlantCare.Strings.GUI_care)
	PlantCare_Frame_LongCareButton:SetText(PlantCare.Strings.GUI_longcare)
	PlantCare_Frame_InfoButton:SetText(PlantCare.Strings.GUI_info)
	
	PlantCare_Frame_Version:SetText(PlantCare.Version)
	PlantCare_Frame_Version:SetColor(1,0.89,0.06)


	GreenThumbFrame_PotInfoFramePottitle :SetColor(0,0.63,0)
	GreenThumbFrame_PotInfoFrameTypetitle:SetColor(0,0.63,0)

	GreenThumbFrame_PotInfoFramePottext  :SetColor(0.6,1,0.3)
	GreenThumbFrame_PotInfoFrameTypetext :SetColor(0.6,1,0.3)

	GreenThumbFrame_SeedInfoFrameMsg2Text:SetColor(0.6,1,0.3)
	Greenthumb_CarePlantButton           :Show()
	GreenThumbFrame_Progress             :Show()

	Sol.hooks.Hook(PlantCare.name, "PlantFrame_Update", PlantCare_PlantFrame_Update)

	SaveVariables("PlantCare_Settings")

	DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] Version "..PlantCare.Version.." loaded.")
	DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..string.format(PlantCare.Strings.SlashHelp3,"|cff00ff00/plantcare help|r"))
end


function PlantCare_SaveConfig()
	local value = tonumber(PlantCare_Properties_Percent_Value:GetText())
	if (value < 0) then
		value = 1
	end
	if (value > 50) then
		value = 50
	end
	PlantCare_Settings.AlertPercentUnder = value
end


function PlantCare_ShowHelp()
	local Counter = PlantCare_Settings.InfoCount
	local doitbaby = 0
	if (PlantCare.displayedHelp == false) then
		Counter = Counter + 1
		if (Counter < 30) then
			doitbaby = 1
		elseif (Counter == 40) then
			Counter = 30
			doitbaby = 1
		end
		PlantCare_Settings.InfoCount = Counter
		if (doitbaby == 1) then
			PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/info.mp3")
			DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..PlantCare.Strings.Help1)
			DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..PlantCare.Strings.Help2)
		end
	end
	PlantCare.displayedHelp = true
end


function PlantCare_LockCareForPlants()
	--
	-- Everything looks good, let's place our mutex..
	-- We don't want to run this function twice at the same time!
	--
	PlantCare.caringForPlants = true
end


function PlantCare_CheckLockCareForPlants()
	return PlantCare.CaringForPlants
end


function PlantCare_UnLockCareForPlants()
	--
	-- Clear our mutex
	--
	PlantCare.caringForPlants = false
end


function PlantCare.Hook_FormalTime(nReapTime)
	local realHours = math.floor((nReapTime/60)/60)
	local realMinutes = math.floor((nReapTime - (realHours*3600)) / 60)
	-- local realSeconds = math.floor(nReapTime-(realHours*3600+realMinutes*60))

	return string.format("%02dh %02dm", realHours, realMinutes)
end


function PlantCare_TimeFormat(seconds)
	if (seconds > 3600) then
		local divide = seconds/3600
		local hours = math.floor(divide)
		local minutes = math.floor((divide-hours)*60)

		local msg = tostring(hours)
		if (hours ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Hours..", "..minutes
		else 
			msg = msg.." "..PlantCare.Strings.Hour..", "..minutes
		end
		if (minutes ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Minutes
		else 
			msg = msg.." "..PlantCare.Strings.Minute
		end

		return msg
	else
		local minutes = math.floor(seconds/60)

		local msg = tostring(minutes)
		if (minutes ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Minutes
		else
			msg = msg.." "..PlantCare.Strings.Minute
		end

		return msg
	end
end


function PlantCare_GetFocusFurnishingID()
	local maxItems, StorageName, FurnishingID = Houses_GetItemInfo(Houses_GetFocusFurnishingID(), -1)
	return FurnishingID
end


function PlantCare_PlantFrame_Update()
	Sol.hooks.GetOriginalFn(PlantCare.name, "PlantFrame_Update")()

	--
	-- Get information about the plant
	--
	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink, fGrowRate, fHealthRate, nReapTime,
	nFeedPoint, nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint, fDecWater, fDecTopdress = Plant_GetInfo()

	--
	-- Set our PlantCare window title to this players current planting skill
	--
	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
	PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

	--
	-- Now check the state of the currently selected plant
	--
	if (szState == "grow" or szState == "ripe") then
		Greenthumb_CarePlantButton:Enable()
	else
		Greenthumb_CarePlantButton:Disable()
	end

	if (szState == "grow") then
		GameTooltip:Hide()
		GameTooltip:SetHyperLink(szSeedLink)
		GameTooltip:Hide()

		GreenThumbFrame_Progress:Show()
		GreenThumbFrame_Progress_Text:SetText(tostring(math.floor(fGrowRate*100)).."%")

		GreenThumbFrame_SeedInfoFrameMsg2:Show()
		GreenThumbFrame_SeedInfoFrameMsg2Text:SetText(string.gsub(GameTooltipTextLeft3:GetText(),"^.*: ","")..", "..C_LEVEL.." "..string.gsub(GameTooltipTextLeft4:GetText(),"[^0-9]","").."\n"..PlantCare_TimeFormat(nReapTime).."\n"..os.date(PlantCare.Strings.Date,os.time()+nReapTime))
		PlantSeedInfoFrameMsg:SetText("|cff00a000"..PlantCare.Strings.Seed..":\n"..PlantCare.Strings.RipeIn..":\n"..PlantCare.Strings.Ripe..":")
	else
		GreenThumbFrame_Progress:Hide()
		GreenThumbFrame_SeedInfoFrameMsg2:Hide()
	end
end


function PlantCare_InfoFrame_PlantList_Catalog_OnClick(this, id)
	if (PlantCare.collect["list"][id]["expand"] == 1) then
		TreeView_SetFolderExpand(PlantCare, PlantCare.collect["list"][id]["id"], 0)
		TreeView_SetListButtonInfo(this, 0)
		PlantCareInfoFrame_PlantDetailFrame:Hide()
	else
		TreeView_SetFolderExpand(PlantCare, PlantCare.collect["list"][id]["id"], 1)
		TreeView_SetListButtonInfo(this, 1)
	end

	PlantCare_InfoFrame_Show(this)
end


function PlantCare_InfoFrame_PlantList_Item_OnClick(this, id)
	if (PlantCare.collect["list"][id]["type"] ~= 0) then
		PlantCareInfoFrame_PlantDetailFrame:Show()
		PlantCareInfoFrame_PlantDetailFrame_HarvestTime:SetText(os.date(PlantCare.Strings.Date, PlantCare.collect["list"][id]["id"].HarvestTime))
		PlantCareInfoFrame_PlantDetailFrame_LastCareTime:SetText(os.date(PlantCare.Strings.Date, PlantCare.collect["list"][id]["id"].LastCareTime))
		PlantCareInfoFrame_PlantDetailFrame_LastHealth:SetText(string.format("%d%%", (100*PlantCare.collect["list"][id]["id"].Health)))
		PlantCareInfoFrame_PlantDetailFrame_LastGrowRate:SetText(string.format("%d%%", (100*PlantCare.collect["list"][id]["id"].GrowRate)))
		PlantCareInfoFrame_PlantDetailFrame_LastTopdressPoint:SetText(PlantCare.collect["list"][id]["id"].TopdressPoint)
		PlantCareInfoFrame_PlantDetailFrame_LastWaterPoint:SetText(PlantCare.collect["list"][id]["id"].WaterPoint)
		PlantCareInfoFrame_PlantDetailFrame_DecWater:SetText(string.format("%.02f", PlantCare.collect["list"][id]["id"].DecWater))
		PlantCareInfoFrame_PlantDetailFrame_DecTopdress:SetText(string.format("%.02f", PlantCare.collect["list"][id]["id"].DecTopdress))

		local currentTopdress = (os.time() - PlantCare.collect["list"][id]["id"].LastCareTime)/3600
		currentTopdress = currentTopdress*PlantCare.collect["list"][id]["id"].DecTopdress
		currentTopdress = PlantCare.collect["list"][id]["id"].TopdressPoint - currentTopdress

		PlantCareInfoFrame_PlantDetailFrame_CalcTopdressPoint:SetText(string.format("%.1f%%", currentTopdress))

		local currentWater = (os.time() - PlantCare.collect["list"][id]["id"].LastCareTime)/3600
		currentWater = currentWater*PlantCare.collect["list"][id]["id"].DecWater
		currentWater = PlantCare.collect["list"][id]["id"].WaterPoint - currentWater

		PlantCareInfoFrame_PlantDetailFrame_CalcWaterPoint:SetText(string.format("%.1f%%", currentWater))
	end
end


function PlantCare_InfoFrame_ResetFrame (frame)
	TreeView_Reset(PlantCare)

	local counter=1
	for i,v in pairs(PlantCare_Settings["HarvestTimes"]) do
		TreeView_SetFolder(PlantCare,i,1)

		counter = counter+1

		times       = {}
		harvestT    = {}
		harvestT[i] = nil
		times[i]    = nil

		for plantID, plantInfoTable in pairs(PlantCare_Settings["HarvestTimes"][i]) do
			TreeView_SetItem(PlantCare,PlantCare_Settings["HarvestTimes"][i][plantID],i)
		end
	end

	if (PlantCareInfoFrame:IsVisible()) then
		PlantCare_InfoFrame_Show(frame)
	end
end


function PlantCare_ColorCareItem(item, point, best)
	if  (point < (best-15)) then
		item:SetColor(1,0,0)
	elseif (point < best-5) then
		item:SetColor(0,0,1)
	else
		item:SetColor(0,1,0)
	end
end


function PlantCare_ColorDiff(item, point, item2, point2)
	local diff = point - point2
	if (diff < 0) then
		diff = diff * -1
	end

	if (diff > 3) then
		item:SetColor(1,0,1,0)
		item2:SetColor(1,0,1,0)
	end
end


function PlantCare_checkWaterState()
	local dotalk = 0
	local addedchar = 0
	local charlist = nil
	local i
	local v

	for i,v in pairs(PlantCare_Settings["HarvestTimes"]) do

		for plantID, plantInfoTable in pairs(PlantCare_Settings["HarvestTimes"][i]) do

			local timediff = (plantInfoTable["HarvestTime"]-os.time())
			local alert = plantInfoTable["alert"]; -- "You have to care for your plants."
			if (alert == nil) then
			  alert = 2
			end
			local notify = plantInfoTable["notify"]; -- "Your plants are ready to be harvested."
			if (notify == nil) then
			  notify = 2
			end

			local currentTopdress = (os.time() - plantInfoTable["LastCareTime"])/3600
			currentTopdress = currentTopdress * plantInfoTable["DecTopdress"]
			currentTopdress = plantInfoTable["TopdressPoint"] - currentTopdress

			local currentWater = (os.time() - plantInfoTable["LastCareTime"])/3600
			currentWater = currentWater * plantInfoTable["DecWater"]
			currentWater = plantInfoTable["WaterPoint"] - currentWater

			if ((currentTopdress <= (plantInfoTable["BestTopdressPoint"]-PlantCare_Settings.AlertPercentUnder)) or (currentWater <= (plantInfoTable["BestWaterPoint"]-PlantCare_Settings.AlertPercentUnder)))
			    and (alert > 0) and (timediff > 0) then
				if (addedchar == 0) then
					if (charlist) then
						charlist = charlist..", "..i
					else
						charlist = i
					end
				end
				alert = alert - 1
				PlantCare_Settings["HarvestTimes"][i][plantID]["alert"] = alert
				addedchar = 1
				dotalk = 1
			end

		end

		addedchar = 0

	end

	if (dotalk == 1) then
		PlaySoundByPath("sound/interface/ui_sysmsg_normal.mp3")
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/care.mp3")
		SystemMsgFrame:AddMessage(PlantCare.Strings.AlertMsg..": "..charlist, 0, 1, 0)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.AlertMsg..": "..charlist)
	end

	return(dotalk)
end


function PlantCare_checkHarvestState()
	local dotalk = 0
	local addedchar = 0
	local charlist = nil
	local i
	local v
	local anzahl

	for i,v in pairs(PlantCare_Settings["HarvestTimes"]) do

		anzahl = 0

		for plantID, plantInfoTable in pairs(PlantCare_Settings["HarvestTimes"][i]) do

			if (plantInfoTable["ID"] == nil) then
				PlantCare_Settings["HarvestTimes"][i][plantID] = nil
			else

				local timediff = (plantInfoTable["HarvestTime"]-os.time())
				local notify = plantInfoTable["notify"]
				local harvested = plantInfoTable["harvested"]

				anzahl = anzahl + 1

				if (notify == nil) then
				  notify = 2
				end
				if (harvested == nil) then
					harvested = 0
				end

				if (timediff < 0) and (timediff > -43200) and (notify > 0) and (plantID > 0) and (harvested == 0) then
					if (addedchar == 0) then
						if (charlist) then
							charlist = charlist..", "..i
						else
							charlist = i
						end
					end
					notify = notify - 1
					PlantCare_Settings["HarvestTimes"][i][plantID]["notify"] = notify
					addedchar = 1
					dotalk = 1
				end
				if (timediff <= -86400) or (plantID < 0) or (harvested == 1) then
					PlantCare_Settings["HarvestTimes"][i][plantID] = nil
					anzahl = anzahl - 1
				end
			end

		end

		-- Delete alts with no entries from list

		if (anzahl == 0) then
			PlantCare_Settings["HarvestTimes"][i] = nil
		end

		addedchar = 0

	end

	if (dotalk == 1) then
		PlaySoundByPath("sound/interface/ui_sysmsg_normal.mp3")
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/harvest.mp3")
		SystemMsgFrame:AddMessage(PlantCare.Strings.timeToHarvest..": "..charlist, 0, 1, 0)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.timeToHarvest..": "..charlist)
	end

	return(dotalk)
end


function PlantCare_InfoFrame_Show(frame)
	local count = TreeView_GetTotalNode(PlantCare)
	local i=1

	if (count ~= nil) then
		local Slider = getglobal("PlantCareInfoFrame_PlantListFrame_ScrollBar")

		Slider:SetMinValue(1)
		if (count - 20 + 1) <= 0  then
			Slider:SetMaxValue(1)
		else
			Slider:SetMaxValue(count-20+1)
		end

		Slider:SetValueStepMode("INT")

		PlantCare.collect = TreeView_GetCollect(PlantCare,Slider:GetValue(),20)
		local item = {}

		while (i <= PlantCare.collect.count) do
			item = PlantCare.collect.list[i]

			local button = getglobal("PlantCareInfoFrame_PlantListFrame_Button" .. i)
			button:Show()

			local buttonItem = getglobal(button:GetName() .. "Item")
			local buttonFolder = getglobal(button:GetName() .. "Folder")

			if item.type == 0 then --folder
				local buttonFolderText = getglobal(button:GetName() .. "FolderText")

				buttonItem:Hide()
				buttonFolder:Show()
				buttonFolderText:SetText(item.id)
			else
				local buttonItemName = getglobal(button:GetName() .. "Item_ItemName")

				buttonFolder:Hide()
				buttonItem:Show()

				local currentTopdress = (os.time() - item.id.LastCareTime)/3600
				currentTopdress = currentTopdress*item.id.DecTopdress
				currentTopdress = item.id.TopdressPoint - currentTopdress

				local currentWater = (os.time() - item.id.LastCareTime)/3600
				currentWater = currentWater*item.id.DecWater
				currentWater = item.id.WaterPoint - currentWater

				local timediff = (item.id.HarvestTime-os.time())/3600

				buttonItemName:SetColor(0.93,0.76,0); -- yellow
				if (currentTopdress <= (item.id.BestTopdressPoint - 20)) or (currentWater <= (item.id.BestWaterPoint - 20)) then buttonItemName:SetColor(1,0,1); end; -- magenta
				if (currentTopdress <= (item.id.BestTopdressPoint - 30)) or (currentWater <= (item.id.BestWaterPoint - 30)) then buttonItemName:SetColor(1,0,0); end; -- red
				if (timediff <= 0) then buttonItemName:SetColor(0,1,0); end;  -- green
				if ((timediff < -10) or (item.id.harvested == 1)) then buttonItemName:SetColor(0.5, 0.5, 0.5); end;  -- grey

				buttonItemName:SetText(string.format("[%d] %s (%.1f|%d|%d)",item.id.ID , item.id.SeedName,  timediff, currentTopdress, currentWater))
			end
			i = i+1
		end
	end

	while (i <= 20) do
		local button = getglobal("PlantCareInfoFrame_PlantListFrame_Button" .. i)
		button:Hide()
		i=i+1
	end
end


function PlantCare_InfoFrame_OnValueChanged(this, arg1)
	--  print(string.format("arg1: %d",arg1))
	PlantCare_InfoFrame_Show(this)
end


function PlantCare:getSeedInfo(seedID)
	local seedTypeNumber = 0
	local stid

	for seedType, seedTable in pairs(PlantCare.Seeds) do
		for stid, seed in pairs(seedTable) do
			if (seed[1] == seedID) then
				if seedType == "Wood" then
					seedTypeNumber = 1
				elseif seedType == "Herb" then
					seedTypeNumber = 2
				elseif seedType == "Ore" then
					seedTypeNumber = 3
				end

				return seedTypeNumber,seed[2]
			end
		end
	end

	return 0,0
end


function PlantCare:grabBestSeed(potType, potLevel)
	local currValue, _, _ = GetPlayerSkilled("PLANT")
	local seedID = 0
	local bestLevel=0
	local bestType=0
	local i

	local occupiedSlots, totalSlots = GetBagCount()
	for i=1, totalSlots do
		local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)

		if (itemLink) then
			local _, itemData, itemName = ParseHyperlink(itemLink)
			local _, _, itemID = string.find(itemData, "^(%x+)")
			itemID = tonumber(itemID, 16)

			local seedType, seedLevel = PlantCare:getSeedInfo(itemID)

			if (potType == 0) then
				-- Multi-purpose: the higher the level the better
				if (seedLevel > bestLevel) and (seedLevel <= currValue) then
					bestLevel = seedLevel
					bestType  = seedType
					seedID = itemID
				end
			else
				--
				-- Try to find exactly matching seed first
				-- otherwise take the seed with the highest level matching the pot type
				-- otherwise take the seed with the highest Level
				--
				if (seedLevel <= currValue) then
					if (seedLevel == potLevel) and (seedType == potType) then
						bestLevel = seedLevel
						bestType  = seedType
						seedID = itemID
					else
						if (seedType == potType) then
							if ((seedLevel > bestLevel) and (bestType == potType) and (bestLevel ~= potLevel)) or (bestType ~= potType) then
								bestLevel = seedLevel
								bestType  = seedType
								seedID = itemID
							end
						else
							if (seedLevel > bestLevel) and (bestType ~= potType) then
								bestLevel = seedLevel
								bestType  = seedType
								seedID = itemID
							end
						end
					end
				end
			end

		end
	end

	return(seedID)
end


function PlantCare:OnEvent(frame, _event, ...)
	-- print("Event: " .. _event)

	if (_event == "HOUSES_PLANT_OPEN") then
		PlantCare_Frame:Show()

		--
		-- Update the picture of the currently selected pot
		--
		local enable, name, texture , Placed, ID = Houses_GetFurnitureItemInfo(PlantCare_GetFocusFurnishingID())
		SetItemButtonTexture(GreenThumbFrame_PotInfoFrameButton, texture)

		--
		-- Set our game tooltip to the currently selected pot
		--
		GreenThumbFrame_InfoTooltip:SetHouseItem(-1 , PlantCare_GetFocusFurnishingID())

		--
		-- Now loop thru all the lines of the tooltip looking for specific information about this pot
		--
		local nPotLevel = nil
		for n=2,7 do
			if (Placed and string.find(getglobal("GreenThumbFrame_InfoTooltipTextLeft"..n):GetText(),string.gsub(TEXT('SYS_NEED_PLANT_SKILL'),"%%d",""),1,true)~=nil) then
				-- don't know, why this doesn't work any more, looks good to me.
				-- nPotLevel = tonumber(string.match(getglobal("GreenThumbFrame_InfoTooltipTextLeft"..n):GetText(), string.gsub(TEXT('SYS_NEED_PLANT_SKILL'), "%%d", "(%%d+)")))
				local anfang
				local ende
				anfang,ende = string.find(getglobal("GreenThumbFrame_InfoTooltipTextLeft"..n):GetText(),"%d+")
				nPotLevel = tonumber(string.sub(getglobal("GreenThumbFrame_InfoTooltipTextLeft"..n):GetText(),anfang,ende))
			end
		end

		--
		-- Get information about the plant
		--
		local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink, fGrowRate, fHealthRate, nReapTime,
		nFeedPoint, nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint, fDecWater, fDecTopdress = Plant_GetInfo()
		local seedType = "?"

		--
		-- Now update our PotInfoFrame
		--
		GreenThumbFrame_PotInfoFramePottext:SetText(szPotName)
		if (nPotType == 0) then seedType = PlantCare.Strings.seedAll; end
		if (nPotType == 1) then seedType = PlantCare.Strings.seedWood; end
		if (nPotType == 2) then seedType = PlantCare.Strings.seedHerb; end
		if (nPotType == 3) then seedType = PlantCare.Strings.seedOre; end
		GreenThumbFrame_PotInfoFrameTypetext:SetText(seedType..", "..PlantCare.Strings.Potlevel.." "..tostring(nPotLevel))

		if (szState == "none") then

			if (PlantCare.currentSeedInHand == 0) then

				local seedID = PlantCare:grabBestSeed(nPotType,nPotLevel)
				

				if (PlantCare_Settings.AutoSeed) and (seedID ~= 0) and (not IsShiftKeyDown()) then
					--
					-- Pot is empty and user wants to plant the best
					-- seed found in backpack
					--
					local occupiedSlots, totalSlots = GetBagCount()
					for i=1, totalSlots do
						local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
						local itemLink = GetBagItemLink(invNr)

						if (itemLink) then
							local _, itemData, itemName = ParseHyperlink(itemLink)
							local _, _, itemID = string.find(itemData, "^(%x+)")
							itemID = tonumber(itemID, 16)

							if (itemID == seedID) then
								-- Clear our "Planting Successful" message count
								PlantCare.BlockMessages[1][2] = 0

								PickupBagItem(invNr)
								Plant_PickupItem("seed")
								Plant_Grow("seed")
								break
							end
						end
					end

					-- Check to see if we need to care for it...
					--
					if (PlantCare_Settings.AutoCare == true) and (not IsShiftKeyDown()) then
						if (PlantCare_CheckLockCareForPlants()) then
							DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants while LOCKED!")
						else
							PlantCare.WaitForPlantingSuccessLoop = 0
							Sol.timers.ScheduleTimer(PlantCare.name, 0.2, PlantCare_WaitForPlantingSuccess)
						end
					end

					local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
					PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

					PlantCare:UpdateTimes()
					PlantCare_InfoFrame_ResetFrame()

				else
					--
					-- If we don't currently have a seed selected and we
					-- clicked on an empty pot, then hide our plant info
					--

					if (PlantCare_Settings.AutoSeed)  then
						SendSystemMsg(PlantCare.Strings.NoSeedFound)
					end

					GreenThumbFrame_Progress:Hide()
					GreenThumbFrame_SeedInfoFrameMsg2:Hide()
				end

			else
				--
				-- If we have a seed selected and we click on an empty pot,
				-- make sure we still have seed left in that stack
				-- and then plant it.  Also feed/water it if autocare is on.
				--
				local occupiedSlots, totalSlots = GetBagCount()

				--
				-- Scan thru our backpack to find a matching itemNbr
				-- for our currently selected seed.  This allows us to
				-- still plant even across stacks.
				--

				local itemCount = 0

				if not IsShiftKeyDown() then

					for i=1, totalSlots do
						local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
						local itemLink = GetBagItemLink(invNr)

						if (itemLink) then
							local _, itemData, itemName = ParseHyperlink(itemLink)
							local _, _, itemID = string.find(itemData, "^(%x+)")
							itemID = tonumber(itemID, 16)

							if (itemID == PlantCare.currentSeedInHand) then
								itemCount = itemCnt

								-- Clear our "Planting Successful" message count
								PlantCare.BlockMessages[1][2] = 0

								PickupBagItem(invNr)
								Plant_PickupItem("seed")
								Plant_Grow("seed")
								break
							end
						end
					end

					if (itemCount == 0) then
						SendSystemMsg(PlantCare.Strings.SeedEmpty)
						DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedEmpty)
						PlantCare.currentSeedInHand = 0
					else
						--
						-- We just planted a seed, if we don't have anymore - display a message.
						--
						itemCount = itemCount - 1
						if (itemCount == 0) then
							SendSystemMsg(PlantCare.Strings.SeedEmpty)
							DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedEmpty)
							PlantCare.currentSeedInHand = 0
						end

						--
						-- Check to see if we need to care for it...
						--
						if PlantCare_Settings.AutoCare == true then
							if (PlantCare_CheckLockCareForPlants()) then
								DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants while LOCKED!")
							else
								PlantCare.WaitForPlantingSuccessLoop = 0
								Sol.timers.ScheduleTimer(PlantCare.name, 0.2, PlantCare_WaitForPlantingSuccess)
							end
						end
					end
				end
			end
		end

		local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
		PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

		if (PlantCare_Settings.AutoCare == true) and (not IsShiftKeyDown()) then
			if (PlantCare_CheckLockCareForPlants()) then
				DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants() while LOCKED!")
			else
				if (PlantCare_Settings.LongCare == true) then
					PlantCare:LongCareForPlants()
				else
					PlantCare_CareForPlants()
				end
			end
		end

		PlantCare:UpdateTimes()
		PlantCare_InfoFrame_ResetFrame()

	elseif (event == "HOUSES_PLANT_CLOSE" or event == "HOUSESFRAME_HIDE") then
		PlantCare_Frame:Hide()

	elseif (_event == "STORE_OPEN") then
		local icon, name, price, moneyType, count, stock = GetStoreSellItemInfo(1)

		if ((PlantCare.Materials.Water[1][1] == name) or (PlantCare.Materials.Water[4][1] == name) or (PlantCare.Materials.Water[7][1] == name)) then


			PlantCareFrame_PlantStoreModifications:Show()
			PlantCare:UpdateMaterialHighlights()
			PlantCare:UpdateMaterialCounts()
			PlantCare:DisplayMaxLevelMaterial()
			PlantCare:DisplayMaxLevelRarity()

			PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Enable()
			PlantCareFrame_PlantStoreModifications_StoreWaterButton:Enable()

			if (IsCtrlKeyDown()) then
				PlantCare:BuyMaterials()
			end
		else
			PlantCareFrame_PlantStoreModifications:Hide()
		end
	elseif (_event == "STORE_CLOSE") then
		PlantCare.counterTimer = 0
		PlantCare.shopWaterDisableTimer = 0
		PlantCare.shopFertilizerDisableTimer = 0
	elseif (_event == "UPDATE_STORE_BUYBACK_ITEMS") or (_event == "UPDATE_STORE_SELL_ITEMS") then
		PlantCare.counterTimer = 2
	end

	if PlantCare[_event] then
		PlantCare[_event](frame, ...)
	end
end


--[[
--   This function sits around waiting for the last seed we planted to finish being planted.
--   I wrote this function because depending on the speed of your system, sometimes recently
--   planted seeds would not get water/fertilizer (with AutoCare turned on) if they took too
--   long to plant.
--
--   ..Castaway
--]]
function PlantCare_WaitForPlantingSuccess()
	if (PlantCare.BlockMessages[1][2] == 0) then
		PlantCare.WaitForPlantingSuccessLoop = PlantCare.WaitForPlantingSuccessLoop + 1

		if (PlantCare.WaitForPlantingSuccessLoop > 20) then
			DEFAULT_CHAT_FRAME:AddMessage("PlantCare encountered an ERROR waiting for your seed to be planted. You may have to manually feed and water.")
			return
		else
			Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
		end
	else
		if (PlantCare_CheckLockCareForPlants()) then
			DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants while LOCKED!")
		else
			if (PlantCare_Settings.LongCare == true) then
				PlantCare:LongCareForPlants()
			else
				PlantCare_CareForPlants()
			end
		end
	end
end


function PlantCare:HOUSES_PLANT_CHANGED()
	--print ("HOUSES_PLANT_CHANGED")

	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
	PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

	PlantCare:UpdateTimes()
	PlantCare_InfoFrame_ResetFrame()
end


function PlantCare:VARIABLES_LOADED()
	Sol.config.CheckSettings(PlantCare.name, PlantCare.DefaultSettings)

	PlantCare:CheckLanguage()
	PlantCare:RegisterWithAddonManager()

	if (PlantCare_Settings.version == nil) then
		PlantCare_Settings.HarvestTimes={}
		PlantCare_Settings.version = 1
	end

	if PlantCare_Settings["HarvestTimes"] == nil then
		PlantCare_Settings["HarvestTimes"] = {}
	end

	if PlantCare_Settings.Enabled then
		PlantCare:Enable()
	end

	PlantCare_Properties_LongCare:SetChecked   			(PlantCare_Settings.LongCare)
	PlantCare_Properties_GetProduct:SetChecked 			(PlantCare_Settings.GetProduct)
	PlantCare_Properties_AutoCare:SetChecked   			(PlantCare_Settings.AutoCare)
	PlantCare_Properties_AlertWater:SetChecked 			(PlantCare_Settings.AlertWater)
	PlantCare_Properties_countPlants:SetChecked			(PlantCare_Settings.CountPlants)
	PlantCare_Properties_autoSeed:SetChecked   			(PlantCare_Settings.AutoSeed)
	PlantCare_Properties_waterBeforeHarvest:SetChecked  (PlantCare_Settings.WaterBeforeHarvest)
	PlantCare_Properties_compensate:SetChecked  		(PlantCare_Settings.Compensate)
	if (not PlantCare_Settings.WaterBeforeHarvest) then
		PlantCare_Properties_compensate:Disable()
		PlantCare_Properties_compensate_Text:SetColor(0.2,0.2,0.2)
	end
	PlantCare_Properties_waterSound:SetChecked 			(PlantCare_Settings.WaterSound)
	PlantCare_Properties_Percent_Value:SetText 			(tostring(PlantCare_Settings.AlertPercentUnder))

	SLASH_APC1 = "/apc"
	SLASH_APC2 = "/plantcare"
	SlashCmdList["APC"] = PlantCare.slash

	-- because old values of MaxLevelMaterial don't work anymore
	local found = false
	local i,v
	for i, v in ipairs(PlantCare.Materials.Levels) do
		if v == PlantCare_Settings.MaxLevelMaterial then
			found = true
		end
	end
	if not found then
		PlantCare_Settings.MaxLevelMaterial = 1
	end
end


function PlantCare_ToggleInfoFrame(this, cmd)
	if (PlantCareInfoFrame:IsVisible()) then
		PlantCareInfoFrame:Hide()
	else
		PlantCareInfoFrame:Show()
	end
end


function PlantCare.slash(_,msg)
	if (msg == nil) or (msg == "") or (msg == "info") then
		if (not PlantCareInfoFrame:IsVisible()) then
			PlantCareInfoFrame:Show()
		end
		if (msg ~= "info") then
			doSHelp = true
		end
	elseif (msg == "settings") or (msg == "properties") then
		if (not PlantCare_Properties:IsVisible()) then
			PlantCare_Properties:Show()
		end
	elseif (msg == "help") then
		DEFAULT_CHAT_FRAME:AddMessage("---[|cff00ff00".."PlantCare|r]-------------------------------")
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.MoreHelp1,"|cff00ff00/plantcare|r","|cff00ff00/apc|r"))
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.SlashHelp1,"|cff00ff00/plantcare info|r"))
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.SlashHelp2,"|cff00ff00/plantcare settings|r"))
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Help1)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Help2)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.MoreHelp2)
		DEFAULT_CHAT_FRAME:AddMessage("-------------------------------------------")
	else
		DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..string.format(PlantCare.Strings.SlashHelp3,"|cff00ff00/plantcare help|r"))
	end
end


function PlantCareOnClickScript()
	PlantCareInfoFrame:Show()
end


function PlantCare:RegisterWithAddonManager()
    if AddonManager then
        local addon = {
            name          = PlantCare.name,
            description   = PlantCare.Strings.description,
            category      = "Other",
            version       = PlantCare.Version,
            author        = "Castaway, Alleris, skite2001, DawnSight, ArneFi",
			miniButton    = PlantCareMiniButton,
			onClickScript = PlantCareOnClickScript,
            enableScript  = PlantCare.Enable,
            disableScript = PlantCare.Disable,
			slashCommands = "/apc, /plantcare",
            icon          = "Interface/Addons/PlantCare/Textures/PlantCareIcon",
        }
        if AddonManager.RegisterAddonTable then
            AddonManager.RegisterAddonTable(addon)
        else
            AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category,
                addon.configFrame, addon.slashCommands, addon.miniButton, addon.onClickScript)
        end
    else
        Sol.io.Print("PlantCare loaded")
    end
end


function PlantCare:CheckLanguage()
	PlantCare_Properties_LongCare_Text:SetText   			(PlantCare.Strings.LongCare)
	PlantCare_Properties_AlertWater_Text:SetText 			(PlantCare.Strings.AlertWaterUnder)
	PlantCare_Properties_countPlants_Text:SetText			(PlantCare.Strings.CountPlants)
	PlantCare_Properties_autoSeed_Text:SetText   			(PlantCare.Strings.AutoSeed)
	PlantCare_Properties_waterBeforeHarvest_Text:SetText	(PlantCare.Strings.WaterBeforeHarvest)
	PlantCare_Properties_compensate_Text:SetText			(PlantCare.Strings.Compensate)
	PlantCare_Properties_waterSound_Text:SetText 			(PlantCare.Strings.WaterSound)
	PlantCare_Properties_GetProduct_Text:SetText 			(PlantCare.Strings.GetProduct)
	PlantCare_Properties_AutoCare_Text:SetText   			(PlantCare.Strings.AutoCare)
	PlantCare_Properties_Header:SetText          			(PlantCare.Addonname.." - "..PlantCare.Strings.SettingsTitle)

	PlantCareInfoFrame_Title:SetText(PlantCare.Addonname.." - "..PlantCare.Strings.InfoTitle)
	PlantCareInfoFrame_SlashText:SetText(PlantCare.Strings.Slash)

	PlantCareInfoFrame_PlantDetailFrame_HarvestTimeDesc:SetText  (PlantCare.Strings.Ripe)
	PlantCareInfoFrame_PlantDetailFrame_LastCareTimeDesc:SetText (PlantCare.Strings.InfoFrom)
	PlantCareInfoFrame_PlantDetailFrame_LastGrowRateDesc:SetText (PlantCare.Strings.LastGrowRate)
	PlantCareInfoFrame_PlantDetailFrame_LastHealthDesc:SetText   (PlantCare.Strings.LastHealth)
	PlantCareInfoFrame_PlantDetailFrame_Topdress:SetText         (PlantCare.Strings.Topdress)
	PlantCareInfoFrame_PlantDetailFrame_Water:SetText            (PlantCare.Strings.Water)
	PlantCareInfoFrame_PlantDetailFrame_Last:SetText             (PlantCare.Strings.LastTime)
	PlantCareInfoFrame_PlantDetailFrame_Drain:SetText            (PlantCare.Strings.Drain)
	PlantCareInfoFrame_PlantDetailFrame_Calculated:SetText       (PlantCare.Strings.Now)
end


function PlantCare:Enable()
	PlantCare_Settings.Enabled = true
	PlantCare.frame:RegisterEvent("HOUSES_PLANT_OPEN")
	PlantCare.frame:RegisterEvent("STORE_OPEN")
	Sol.hooks.Hook(PlantCare.name, "PlantFrame_FormalTime", PlantCare.Hook_FormalTime)
	Sol.hooks.Hook(PlantCare.name, "BagItemButton_OnClick", PlantCare.BagItemButton_OnClick)
	if (type(zBag)=="table" and type(zBagItem1)=="table") then
		Sol.hooks.Hook(PlantCare.name, "zBagItem_OnClick", PlantCare.zBagItemButton_OnClick)
	end

	Sol.hooks.Hook(PlantCare.name, "StoreFrame_SellUpdate", PlantCare.SellUpdate)
	Sol.hooks.Hook(PlantCare.name, "ChatFrame_OnEvent",     PlantCare.ChatFrame_OnEvent)
end


function PlantCare:Disable()
	PlantCare_Settings.Enabled = false
	PlantCare.frame:UnregisterEvent("HOUSES_PLANT_OPEN")
	PlantCare.frame.UnregisterEvent("STORE_OPEN")
	Sol.hooks.UnHook(PlantCare.name, "PlantFrame_FormalTime")
	Sol.hooks.UnHook(PlantCare.name, "BagItemButton_OnClick")
	if (type(zBag)=="table" and type(zBagItem1)=="table") then
		Sol.hooks.UnHook(PlantCare.name, "zBagItem_OnClick")
	end
	Sol.hooks.UnHook(PlantCare.name, "StoreFrame_SellUpdate")
	Sol.hooks.UnHook(PlantCare.name, "ChatFrame_OnEvent")
end


function PlantCare:Toggle()
    if not PlantCare_Settings.Enabled then
        PlantCare:Enable()
        Sol.io.Print("PlantCare enabled ")
    else
        PlantCare:Disable()
        Sol.io.Print("PlantCare disabled ")
    end
end


function PlantCare:UpdateTimes(updateSettings)
	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()

	local playerName = UnitName("player")

	if PlantCare_Settings["HarvestTimes"][playerName] == nil then
		PlantCare_Settings["HarvestTimes"][playerName] = {}
	end

	local furnishID = Houses_GetFocusFurnishingID()

	if PlantCare_Settings["HarvestTimes"][playerName][furnishID] == nil then
		PlantCare_Settings["HarvestTimes"][playerName][furnishID] = {}
	end

	local dateString = ""

	if szState == "grow" then
		local realHours   = math.floor((nReapTime/60)/60)
		local realMinutes = math.floor((nReapTime - (realHours*3600)) / 60)
		local realSeconds = math.floor(nReapTime-(realHours*3600+realMinutes*60))

		local harvestTable = os.date("*t", (os.time() + nReapTime))
		local dateTable    = os.date("*t")

		if dateTable.day == harvestTable.day then
			dateString = string.format("%s\n%02d:%02d:%02d", PlantCare.Strings.Today, harvestTable.hour, harvestTable.min, harvestTable.sec)
		else
			dateString = string.format("%02d.%02d.%04d\n%02d:%02d", harvestTable.day, harvestTable.month, harvestTable.year, harvestTable.hour, harvestTable.min)
		end

		if (nWaterPoint > (nBestWaterPoint - PlantCare_Settings.AlertPercentUnder)) and (nTopdressPoint > (nBestTopdressPoint - PlantCare_Settings.AlertPercentUnder)) then
			PlantCare_Settings["HarvestTimes"][playerName][furnishID].alert        = 2
		end

		PlantCare_Settings["HarvestTimes"][playerName][furnishID]["HarvestTime"]    = os.time() + nReapTime
		PlantCare_Settings["HarvestTimes"][playerName][furnishID]["LastCareTime"]   = os.time()
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].SeedName          = szSeedName
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].GrowRate          = fGrowRate
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].Health            = fHealthRate
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].TopdressPoint     = nTopdressPoint
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].BestTopdressPoint = nBestTopdressPoint
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].WaterPoint        = nWaterPoint
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].BestWaterPoint    = nBestWaterPoint
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].DecWater          = fDecWater
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].DecTopdress       = fDecTopdress
		PlantCare_Settings["HarvestTimes"][playerName][furnishID].ID                = furnishID
		if PlantCare_Settings["HarvestTimes"][playerName][furnishID].notify == nil then
			PlantCare_Settings["HarvestTimes"][playerName][furnishID].notify        = 2
		end
		if (PlantCare_Settings["HarvestTimes"][playerName][furnishID].harvested == nil) or (nReapTime > 0) then
			PlantCare_Settings["HarvestTimes"][playerName][furnishID].harvested     = 0
		end
		if PlantCare_Settings["HarvestTimes"][playerName][furnishID].alert == nil then
			PlantCare_Settings["HarvestTimes"][playerName][furnishID].alert        = 2
		end
	else
		-- PlantCare_Settings["HarvestTimes"][playerName][furnishID]=nil
		-- besides it doesn't work (any more?), we need it a little while longer for the reminder
		-- and that's where we are going to delete the entries...
	end

	PlantCare_PlantTime_String:SetText(dateString)
end


function PlantCare:LongCareForPlants()
	if (PlantCare_CheckLockCareForPlants()) then
		DEFAULT_CHAT_FRAME:AddMessage("LongCareForPlants() LOCKED!")
		return
	end

	local didsth = 0

	PlantCare_LockCareForPlants()

	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
	fGrowRate, fHealthRate, nReapTime, nFeedPoint,
	nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
	fDecWater, fDecTopdress = Plant_GetInfo()

	if szState == "ripe" then
		PlantCare_WaterHarvest()
		return
	elseif szState == "death" then
		if PlantCare_Settings.GetProduct then
			PlantFrameClearBatton_OnClick()
		end

		PlantCare_UnLockCareForPlants()
		return

	elseif szState == "grow" then
	
		PlantCare:GrabWater()
		local waterCount = PlantCare:calcLongCareCount(nWaterPoint, nBestWaterPoint, 1)
		
		while (waterCount > 0) do
			Plant_Grow("water")
			PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
			if (PlantCare.waterGrabbed == 0) then
				PlantCare.action = "long"
				PlantCare_UnLockCareForPlants()
				PlantCare.Counter = 0.5
				return
			end
			didsth = 1
			waterCount = waterCount - 1
		end
		
		PlantCare:GrabTopdress()
		local topdressCount = PlantCare:calcLongCareCount(nTopdressPoint, nBestTopdressPoint, 2)
		

		while (topdressCount > 0) do
			Plant_Grow("topdress")
			topdressCount = topdressCount - 1
			PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
			if (PlantCare.topdressGrabbed == 0) then
				PlantCare.action = "long"
				PlantCare_UnLockCareForPlants()
				PlantCare.Counter = 0.5
				return
			end
			didsth = 1
		end

		if (didsth == 1) then
			PlantCare:CountAndSound()
		end

	end

	Sol.timers.ScheduleTimer(PlantCare.name, 1.0, PlantCare_UnLockCareForPlants())
end


function PlantCare:FeedPlant(overwaterFlag, nTopdressPoint, nBestTopdressPoint)
	local didsth = 0

	PlantCare:GrabTopdress()
	local times = PlantCare:calcCareCount(nTopdressPoint, nBestTopdressPoint, 2)
	

	while (times > 0) do
		Plant_Grow("topdress")
		times = times - 1
		didsth = 1
		PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
		if ((PlantCare.topdressGrabbed == 0) and (times > 0)) then
			PlantCare.action = "normal"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return(-1)
		end
	end
	return (didsth)
end


function PlantCare:WaterPlant(overwaterFlag, nWaterPoint, nBestWaterPoint)
	local didsth = 0

	PlantCare:GrabWater()
	local times = PlantCare:calcCareCount(nWaterPoint, nBestWaterPoint, 1)
	
	while (times > 0) do
		Plant_Grow("water")
		times = times - 1
		didsth = 1
		PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
		if ((PlantCare.waterGrabbed == 0) and (times > 0)) then
			PlantCare.action = "normal"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return (-1)
		end
	end
	return (didsth)
end


function PlantCare_WaterHarvest()
	if PlantCare_Settings.WaterBeforeHarvest then
		PlantCare_WaterBeforeHarvest()
	else
		if PlantCare_Settings.GetProduct then
			Plant_GetProduct()
			PlantCare_Settings["HarvestTimes"][UnitName("player")][Houses_GetFocusFurnishingID()]["harvested"] = 1
		end
		PlantCare_UnLockCareForPlants()
	end
end


function PlantCare_WaterBeforeHarvest()
	if (PlantCare_CheckLockCareForPlants()) then
		DEFAULT_CHAT_FRAME:AddMessage("LongCareForPlants() LOCKED!")
		return
	end

	PlantCare_LockCareForPlants()

	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()
	
	local smallFeed = 40
	local bigFeed = 85
	local delta
	
	for seedType, seedTable in pairs(PlantCare.Seeds) do
		for stid, seed in pairs(seedTable) do
			if (szSeedName == TEXT('Sys'..tostring(seed[1])..'_name')) then
				smallFeed = seed[3]
				bigFeed = seed[4]
			end
		end
	end

	local bestFeed = smallFeed

	if (PlantCare_Settings.Compensate) then
		if ((fHealthRate * 100) < bigFeed) then
			bestFeed = bigFeed
		end
	end
	
	PlantCare:GrabWater()
	local waterCount = 0
	PlantCare:GrabTopdress()
	local topdressCount = 0
	
	if (nFeedPoint < bestFeed) then
		delta = math.ceil((bestFeed - nFeedPoint) / 2)
		waterCount = math.ceil(delta / PlantCare.currentWaterFeeds)
		topdressCount = math.ceil(delta / PlantCare.currentFertilizerFeeds)
	end
	
	while (waterCount > 0) do
		Plant_Grow("water")
		PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
		if (PlantCare.waterGrabbed == 0) then
			PlantCare.action = "over"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return
		end
		waterCount = waterCount - 1
	end
	
	while (topdressCount > 0) do
		Plant_Grow("topdress")
		PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
		if (PlantCare.topdressGrabbed == 0) then
			PlantCare.action = "over"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return
		end
		topdressCount = topdressCount - 1
	end

	if PlantCare_Settings.GetProduct then
		Plant_GetProduct()
		PlantCare_Settings["HarvestTimes"][UnitName("player")][Houses_GetFocusFurnishingID()]["harvested"] = 1
	end

	Sol.timers.ScheduleTimer(PlantCare.name, 1.0, PlantCare_UnLockCareForPlants())
end


function PlantCare_CareForPlants()
	if (IsShiftKeyDown()) then
		PlantCare:LongCareForPlants()
	else
		if (PlantCare_CheckLockCareForPlants()) then
			DEFAULT_CHAT_FRAME:AddMessage("CareForPlants() LOCKED!")
			return
		end

		PlantCare_LockCareForPlants()

		local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()

		if szState == "ripe" then
			PlantCare_WaterHarvest()
			return
		elseif szState == "death" then
			if PlantCare_Settings.GetProduct then
				PlantFrameClearBatton_OnClick()
			end

			PlantCare_UnLockCareForPlants()
			return

		elseif szState == "grow" then
			local overwaterFlag = 1
			local didwater = 0
			local didfertilizer = 0

			didfertilizer = PlantCare:FeedPlant(overwaterFlag, nTopdressPoint, nBestTopdressPoint)
			didwater = PlantCare:WaterPlant(overwaterFlag, nWaterPoint, nBestWaterPoint)

			if ((didwater == 1) or (didfertilizer == 1)) then
				if ((didwater >= 0) and (didfertilizer >= 0)) then
					PlantCare:CountAndSound()
				end
			end
		end

		Sol.timers.ScheduleTimer(PlantCare.name, 2.0, PlantCare_UnLockCareForPlants())
	end
end


function PlantCare:CountAndSound()
	if (PlantCare_Settings.WaterSound == true) then
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/ding.mp3")
	end
	if (PlantCare_Settings.CountPlants == true) then
		PlantCare.plantCounter = PlantCare.plantCounter + 1
		PlantCare.resetTimer = 30
		SystemMsgFrame:AddMessage(PlantCare.plantCounter, 0, 1, 0)
		if (PlantCare_Settings.WaterSound ~= true) then
			PlaySoundByPath("sound\\interface\\ui_sysmsg_normal.mp3")
		end
	end
end


function PlantCare:calcCareCount(current, best, type)
	if (best == 90) then
		best = 93
	elseif (best == 85) then
		best = 91
	elseif (best == 80) then
		best = 87
	elseif (best == 70) then
		best = 80
	end

	if (type == 2) then
		return math.floor((best-current)/ PlantCare.currentFertilizerSteps)
	else
		return math.floor((best-current)/ PlantCare.currentWaterSteps)
	end
end

function PlantCare:calcLongCareCount(current, best, type)
	if (best == 90) then
		best = 100
	elseif (best == 85) then
		best = 100
	elseif (best == 80) then
		best = 95
	elseif (best == 70) then
		best = 90
	end

	if (type == 2) then
		return math.floor((best-current)/ PlantCare.currentFertilizerSteps)
	else
		return math.floor((best-current)/ PlantCare.currentWaterSteps)
	end
end


function PlantCare:getBestConsumable(type)
	--
	-- gets the best water or fertilizer from the backpack
	--

	local searchTable
	if (type == "water") then
		searchTable = PlantCare.Materials.Water
	elseif (type == "fertilizer") then
		searchTable = PlantCare.Materials.Fertilizer
	else
		return 0
	end

	local i,s,v
	local occupiedSlots, totalSlots = GetBagCount()
	local bestName
	local bestLevel = 0
	local bestRarity = 0
	local plantlevel=PlantCare:GetPlantLevel()

	for i=1, totalSlots do
		local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)

		for s, v in pairs(searchTable) do
			if (name == v[1]) then
				if (((v[2] > bestLevel) and (v[3] == bestRarity)) or
				   (v[3] > bestRarity)) and
				   (v[2] <= plantlevel) then
					bestRarity = v[3]
					bestLevel = v[2]
					bestName = v[1]
				end
			end
		end

	end

	return bestName
end


function PlantCare:GrabWater()
    local occupiedSlots, totalSlots = GetBagCount()
	local bestName = PlantCare:getBestConsumable("water")
	local i,k,v

    for i=1, totalSlots do
        local invNr, _, bagname, quantity = GetBagItemInfo(i)
		if (bestName == 0) or (bestName == bagname) then
			local itemLink = GetBagItemLink(invNr)
			if (itemLink) then
				local _, itemData, itemName = ParseHyperlink(itemLink)
				local _, _, itemID = string.find(itemData, "^(%x+)")
				itemID = tonumber(itemID, 16)
				PlantCare.currentWaterSteps = 10
				PlantCare.currentWaterFeeds = 1

				for k,v in pairs(PlantCare.Materials.Water) do
					if bagname == v[1] then
						PlantCare.currentWaterSteps = v[4]
						PlantCare.currentWaterFeeds = v[6]
						PlantCare.waterGrabbed = quantity
						PickupBagItem(invNr)
						Plant_PickupItem("water")
						return
					end
				end
			end
		end
    end
end


function PlantCare:GrabTopdress()

    local occupiedSlots, totalSlots = GetBagCount()
	local bestName = PlantCare:getBestConsumable("fertilizer")

    for i=1, totalSlots do
		local invNr, _, bagname, quantity  = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)
		if (bestName == 0) or (bestName == bagname) then
			if (itemLink) then
				local _, itemData, itemName = ParseHyperlink(itemLink)
				local _, _, itemID = string.find(itemData, "^(%x+)")
				itemID = tonumber(itemID, 16)
				PlantCare.currentFertilizerSteps = 10
				PlantCare.currentFertilizerFeeds = 1

				for k,v in pairs(PlantCare.Materials.Fertilizer) do
					if bagname == v[1] then
						PlantCare.currentFertilizerSteps = v[4]
						PlantCare.currentFertilizerFeeds = v[6]
						PlantCare.topdressGrabbed = quantity
						PickupBagItem(invNr)
						Plant_PickupItem("topdress")
						return
					end
				end
			end
		end
    end
end


function PlantCare.zBagItemButton_OnClick(bagButton, ...)
	if (PlantFrame:IsVisible()) then
		PlantCare_ShowHelp()
	end

	if IsCtrlKeyDown() and PlantFrame:IsVisible() then
		--
		-- AutoPlant this seed
		--
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)
			-- print(string.format(" item debug: [%i] %s", itemid, itemname))

			-- Clear our "Planting Successful" message count
			PlantCare.BlockMessages[1][2] = 0

			PickupBagItem(bagButton.index)
			Plant_PickupItem("seed")
			Plant_Grow("seed")

			if PlantCare_Settings.AutoCare then
				if (PlantCare_CheckLockCareForPlants()) then
					DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants() while LOCKED!")
				else
					PlantCare.WaitForPlantingSuccessLoop = 0
					Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
				end
			end
		end

	elseif IsAltKeyDown() and PlantFrame:IsVisible() then
		--
		-- Store this seed information for planting later...
		--

		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)
			-- DEFAULT_CHAT_FRAME:AddMessage(string.format(" item debug: [%i] %s", itemid, itemname))

			if (PlantCare.currentSeedInHand == itemid) then
				SendSystemMsg(PlantCare.Strings.SeedUnSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedUnSelected)
				PlantCare.currentSeedInHand = 0
			else
				SendSystemMsg(PlantCare.Strings.SeedSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedSelected)
				PlantCare.currentSeedInHand = itemid
			end
		end
	else
		Sol.hooks.GetOriginalFn(PlantCare.name, "zBagItem_OnClick")(bagButton, ...)
	end
end


function PlantCare.BagItemButton_OnClick(bagButton, ...)
	if (PlantFrame:IsVisible()) then
		PlantCare_ShowHelp()
	end

	if IsCtrlKeyDown() and PlantFrame:IsVisible() then
		--
		-- AutoPlant this seed
		--
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)
			-- print(string.format(" item debug: [%i] %s", itemid, itemname))

			-- Clear our "Planting Successful" message count
			PlantCare.BlockMessages[1][2] = 0

			PickupBagItem(bagButton.index)
			Plant_PickupItem("seed")
			Plant_Grow("seed")

			if PlantCare_Settings.AutoCare then
				if (PlantCare_CheckLockCareForPlants()) then
					DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants() while LOCKED!")
				else
					PlantCare.WaitForPlantingSuccessLoop = 0
					Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
				end
			end
		end

	elseif IsAltKeyDown() and PlantFrame:IsVisible() then
		--
		-- Store this seed information for planting later...
		--
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)
			-- print(string.format(" item debug: [%i] %s", itemid, itemname))

			if (PlantCare.currentSeedInHand == itemid) then
				SendSystemMsg(PlantCare.Strings.SeedUnSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedUnSelected)
				PlantCare.currentSeedInHand = 0
			else
				SendSystemMsg(PlantCare.Strings.SeedSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedSelected)
				PlantCare.currentSeedInHand = itemid
			end
		end
	else
		Sol.hooks.GetOriginalFn(PlantCare.name, "BagItemButton_OnClick")(bagButton, ...)
	end
end


function PlantCare_OnUpdate(frame, elapsedTime)
	if (not PlantFrame:IsVisible()) then
		PlantCare_Frame:Hide()
	end
	if (PlantCare.Counter > 0) then
		PlantCare.Counter = PlantCare.Counter - elapsedTime
		if (PlantCare.Counter <= 0) then
			if (PlantCare.action == "normal") then
				PlantCare_CareForPlants()
			elseif (PlantCare.action == "long") then
				PlantCare:LongCareForPlants()
			elseif (PlantCare.action == "over") then
				PlantCare_WaterBeforeHarvest()
			end
		end
	end
end


function PlantCare_ReminderUpdate(frame, elapsedTime)
	PlantCare.watchCounter = PlantCare.watchCounter - elapsedTime
	if (PlantCare.watchCounter <= 0) then
		PlantCare.watchCounter = 300
		if (PlantCare_checkHarvestState() == 0) then
			if (PlantCare_Settings.AlertWater == true) then
				PlantCare_checkWaterState()
			end
		end
	end

	if (PlantCare.resetTimer > 0) then
		PlantCare.resetTimer = PlantCare.resetTimer - elapsedTime
		if (PlantCare.resetTimer <= 0) then
			PlantCare.plantCounter = 0
		end
	end

	if (PlantCare.counterTimer > 0) then
		PlantCare.counterTimer = PlantCare.counterTimer - elapsedTime
		if (PlantCare.counterTimer <= 0) then
			PlantCare:UpdateMaterialCounts()
		end
	end

	if (PlantCare.shopWaterDisableTimer > 0) then
		PlantCare.shopWaterDisableTimer = PlantCare.shopWaterDisableTimer - elapsedTime
		if (PlantCare.shopWaterDisableTimer <= 0) then
			PlantCareFrame_PlantStoreModifications_StoreWaterButton:Enable()
		end
	end
	if (PlantCare.shopFertilizerDisableTimer > 0) then
		PlantCare.shopFertilizerDisableTimer = PlantCare.shopFertilizerDisableTimer - elapsedTime
		if (PlantCare.shopFertilizerDisableTimer <= 0) then
			PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Enable()
		end
	end
end


function PlantCare.ChatFrame_OnEvent(this, event)
	if ((PlantFrame:IsVisible()) and (event == "CHAT_MSG_SYSTEM")) then
		for n=1,table.maxn(PlantCare.BlockMessages) do
			if (string.match(arg1, PlantCare.BlockMessages[n][1])) then
				PlantCare.BlockMessages[n][2] = PlantCare.BlockMessages[n][2] + 1
				return
			end
		end
		if (Houses_GetFocusFurnishingID()) then
			local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
			PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")
		end
	end
	Sol.hooks.GetOriginalFn(PlantCare.name, "ChatFrame_OnEvent")(this, event)
end


--[[
--
--   PlantCare Store Modificiations
--
--]]


function PlantCare:GetPlantLevel()
	-- a := Level of Water/Fertilizer that's <= Player's planting skill
	-- b := Maxlevel of Water/Fertilizer to buy (set by user)
	-- this function returns min(a,b)

	local plantlevel=1
	local i
	local v
	local newValue = 0
	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")

	if (currValue >= PlantCare_Settings.MaxLevelMaterial) then
		plantlevel = PlantCare_Settings.MaxLevelMaterial
	else
		for i, v in ipairs(PlantCare.Materials.Levels) do
			if (v <= currValue) and (newValue < v) then
				newValue = v
			end
		end
		plantlevel = newValue
	end

	return plantlevel
end


function PlantCare.SellUpdate()
	Sol.hooks.GetOriginalFn(PlantCare.name, "StoreFrame_SellUpdate")()
	PlantCare:UpdateMaterialHighlights()
	PlantCare:UpdateMaterialCounts()
end


function PlantCare:StoreFrameTooltip(this)
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")

	if (this:GetName()=="PlantCareFrame_PlantStoreModifications_StoreWaterButton") then
		GameTooltip:SetText(PlantCare.Strings.BuyWater1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.BuyWater2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_StoreFertilizerButton") then
		GameTooltip:SetText(PlantCare.Strings.BuyFert1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.BuyFert2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_MaxLevelMaterial") then
		GameTooltip:SetText(PlantCare.Strings.MaxLevel1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.MaxLevel2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_Rarities") then
		GameTooltip:SetText(PlantCare.Strings.MaxRarity1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.MaxRarity2,0.6,1,0.3)
	end
end


function PlantCare:getBestWaterIndex()
	local plantlevel=PlantCare:GetPlantLevel()
	local n
	local suggestedLevel = 0
	local suggestedRarity = 0
	local WaterIndex = 0

	for n=1,10 do
		for i, v in ipairs(PlantCare.Materials.Water) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Water[i][1]) then
				if (((PlantCare.Materials.Water[i][2] > suggestedLevel) and (PlantCare.Materials.Water[i][3] == suggestedRarity)) or
					(PlantCare.Materials.Water[i][3] > suggestedRarity)) and
					(PlantCare.Materials.Water[i][2] <= plantlevel) and
					(PlantCare.Materials.Water[i][3] <= PlantCare_Settings.MaxLevelRarity) then
					suggestedLevel = PlantCare.Materials.Water[i][2]
					suggestedRarity = PlantCare.Materials.Water[i][3]
					WaterIndex = i
				end
			end
		end
	end
	return(WaterIndex)
end


function PlantCare:getBestFertilizerIndex()
	local plantlevel=PlantCare:GetPlantLevel()
	local n
	local suggestedLevel = 0
	local suggestedRarity = 0
	local FertilizerIndex = 0

	for n=1,10 do
		for i, v in ipairs(PlantCare.Materials.Fertilizer) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Fertilizer[i][1]) then
				if (((PlantCare.Materials.Fertilizer[i][2] > suggestedLevel) and (PlantCare.Materials.Fertilizer[i][3] == suggestedRarity)) or
					(PlantCare.Materials.Fertilizer[i][3] > suggestedRarity)) and
					(PlantCare.Materials.Fertilizer[i][2] <= plantlevel) and
					(PlantCare.Materials.Fertilizer[i][3] <= PlantCare_Settings.MaxLevelRarity) then
					suggestedLevel = PlantCare.Materials.Fertilizer[i][2]
					FertilizerIndex = i
				end
			end
		end
	end
	return(FertilizerIndex)
end


function PlantCare:UpdateMaterialCounts()
	local n
	local m

	for n=1,10 do
		for m = 1, table.maxn(PlantCare.Materials.Water) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Water[m][1]) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),GetCountInBagByName(PlantCare.Materials.Water[m][1]))
			end
		end

		for m = 1, table.maxn(PlantCare.Materials.Fertilizer) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Fertilizer[m][1]) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),GetCountInBagByName(PlantCare.Materials.Fertilizer[m][1]))
			end
		end
	end
end


function PlantCare:UpdateMaterialHighlights()
	PlantCareFrame_PlantStoreModifications_Highlight_Water:Hide()
	PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:Hide()

	-- what's the best usable level on this page?
	local WaterIndex      = PlantCare:getBestWaterIndex()
	local FertilizerIndex = PlantCare:getBestFertilizerIndex()

	for n=1,10 do
		if (WaterIndex > 0) then
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Water[WaterIndex][1]) then
				PlantCareFrame_PlantStoreModifications_Highlight_Water:ClearAllAnchors()
				PlantCareFrame_PlantStoreModifications_Highlight_Water:SetAnchor("CENTER", "CENTER", getglobal("StoreFrameItem"..n.."Button"), 0, 0)
				PlantCareFrame_PlantStoreModifications_Highlight_Water:Show()
			end
		end

		if (FertilizerIndex > 0) then
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Fertilizer[FertilizerIndex][1]) then
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:ClearAllAnchors()
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:SetAnchor("CENTER", "CENTER", getglobal("StoreFrameItem"..n.."Button"), 0, 0)
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:Show()
			end
		end
	end
end


function PlantCare:DisplayMaxLevelMaterial()
	PlantCareFrame_PlantStoreModifications_MaxLevelMaterial_Text:SetText(tostring(PlantCare_Settings.MaxLevelMaterial))

	if (PlantCare_Settings.MaxLevelMaterial == 1) then
		PlantCareFrame_PlantStoreModifications_MaterialsMinus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_MaterialsMinus:Enable()
	end

	if (PlantCare_Settings.MaxLevelMaterial == PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]) then
		PlantCareFrame_PlantStoreModifications_MaterialsPlus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_MaterialsPlus:Enable()
	end
end


function PlantCare:DisplayMaxLevelRarity()
	local i
	if (PlantCare_Settings.MaxLevelRarity == 0) then
		PlantCareFrame_PlantStoreModifications_RarityMinus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_RarityMinus:Enable()
	end

	if (PlantCare_Settings.MaxLevelRarity == 2) then
		PlantCareFrame_PlantStoreModifications_RarityPlus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_RarityPlus:Enable()
	end

	for i=0,5 do
		local RarityTexture = getglobal("PlantCareFrame_PlantStoreModifications_Rarities_Rarity"..i)
		if i == PlantCare_Settings.MaxLevelRarity then
			RarityTexture:Show()
		else
			RarityTexture:Hide()
		end
	end
end


function PlantCare:ChangeMaxLevelMaterials(int)
	local i
	local v
	local newLevel

	for i, v in ipairs(PlantCare.Materials.Levels) do
		if PlantCare_Settings.MaxLevelMaterial == v then
			newLevel = PlantCare.Materials.Levels[i+int]
		end
	end

	PlantCare_Settings.MaxLevelMaterial = newLevel


	if (PlantCare_Settings.MaxLevelMaterial < 1) then
		PlantCare_Settings.MaxLevelMaterial = 1
	end

	if (PlantCare_Settings.MaxLevelMaterial > PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]) then
		PlantCare_Settings.MaxLevelMaterial = PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]
	end

	PlantCare:DisplayMaxLevelMaterial()
	PlantCare:UpdateMaterialHighlights()
end


function PlantCare:ChangeMaxLevelRarity(int)
	PlantCare_Settings.MaxLevelRarity = PlantCare_Settings.MaxLevelRarity + int


	if (PlantCare_Settings.MaxLevelRarity < 0) then
		PlantCare_Settings.MaxLevelRarity = 0
	end

	if (PlantCare_Settings.MaxLevelRarity > 2) then
		PlantCare_Settings.MaxLevelRarity = 2
	end

	PlantCare:DisplayMaxLevelRarity()
	PlantCare:UpdateMaterialHighlights()
end


function PlantCare:BuyMaterials(item)
	--local plantlevel=PlantCare:GetPlantLevel()

	local WaterIndex      = PlantCare:getBestWaterIndex()
	local FertilizerIndex = PlantCare:getBestFertilizerIndex()

	local BuyWater = 0
	local BuyFert  = 0
	local bagitems, bagsize = GetBagCount()

	--
	-- due to ch4-updates we have to fill up each stack separately
	--

	for i=1,bagsize do
		local index, texture, name, itemCount, locked, invalid = GetBagItemInfo(i)

		if ((item == nil or item == "water") and (name == PlantCare.Materials.Water[WaterIndex][1]) and (BuyWater == 0)) then
			BuyWater = BuyWater + PlantCare.Materials.Water[WaterIndex][5] - itemCount
		end

		if ((item == nil or item == "fertilizer") and (name == PlantCare.Materials.Fertilizer[FertilizerIndex][1]) and (BuyFert == 0)) then
			BuyFert  = BuyFert  + PlantCare.Materials.Fertilizer[FertilizerIndex][5] - itemCount
		end
	end

	--
	-- If all of our stacks are currently full, or we don't have any stacks
	-- then purchase a complete new stack of 250
	--
	if (item == "water"      and BuyWater == 0) then BuyWater = PlantCare.Materials.Water[WaterIndex][5]; end
	if (item == "fertilizer" and BuyFert  == 0) then BuyFert  = PlantCare.Materials.Fertilizer[FertilizerIndex][5]; end

	local index=1
	while true do
		local icon, name, price, moneyType, count, stock = GetStoreSellItemInfo(index)

		if (name==nil) then break; end

		if (BuyWater > 0 and PlantCare.Materials.Water[WaterIndex][1]==name) then
			PlantCare.counterTimer = 2
			if (BuyWater < PlantCare.Materials.Water[WaterIndex][5]) and (BuyWater > 0) then
				PlantCareFrame_PlantStoreModifications_StoreWaterButton:Disable()
				PlantCare.shopWaterDisableTimer = 2
			end
			StoreBuyItem(index, BuyWater)
		end

		if (BuyFert > 0 and PlantCare.Materials.Fertilizer[FertilizerIndex][1]==name) then
			PlantCare.counterTimer = 2
			if (BuyFert < PlantCare.Materials.Fertilizer[FertilizerIndex][5]) and (BuyFert > 0) then
				PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Disable()
				PlantCare.shopFertilizerDisableTimer = 2
			end
			StoreBuyItem(index, BuyFert)
		end

		index=index+1
	end
end

function PlantCare.log(message)
	local n
	for n=1,10 do
		if getglobal("ChatFrame"..n):IsVisible() then
			getglobal("ChatFrame"..n):AddMessage("[|cff00ff00".."PlantCare|r] "..message)
		end
	end
end
